$Title Sets Definition
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
         Hybrid Top-down Computable General Equilibrium and Bottom-up Electricity Expansion Model
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 26, may, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext

*-------------------------------------------------------------------------------
*--------------------------- Declaring parameters ------------------------------
*-------------------------------------------------------------------------------
Parameters
*SAM parameters
e_ii_s(y,sam,sam)                mill.  sector s intermediate input expenditure in buying good g
e_pf_s(y,pf,sam)                 mill.  sector s expenditure in production factor pf payments
e_tx_sam(y,tx,sam)               mill.  sector-institution-investment-exports expenditure in tax tx payments
e_m_s(y,sam)                     mill.  sector s expenditure in imports
e_g_i(y,sam,i)                   mill.  institution i expenditure in buying good g
e_transf_i(y,i,i2)               mill.  transfers between institutions (i2 pays to i)
e_transf_k_i_ext(y,i)            mill.  institution i capital tranfer to the exterior
e_i_pf(y,i,pf)                   mill.  institution i receipts from  production factor endownment
e_i_tx(y,i,tx)                   mill.  institution i receipts from tax tx
e_i_sav(y,i)                     mill.  savings of institution i
e_inv(y,sam)                     mill.  good g investments
e_sav(y)                         mill.  total external savings
e_g_ex(y,sam)                    mill.  good g exports receipts
e_transf_i_s(y,i,s)              mill.  government subsidies and direct transfers to productive sector (ex. government CO2 emission allowances given to electricity sector)
e_transf_k_ext_i(y,i)            mill.  exterior capital tranfer to institution i
e_transf_k_ext_spain(y)          mill.  exterior capital tranfer to Spain
*Top-down parameters
elasticity_va(s)                 p.u.    elasticity of substitution between capital and labor productive factors
elasticity_d(g)                  p.u.    elasticity of substitution between domestic-European-rest of the world offer goods
elasticity_q(g)                  p.u.    elasticity of transformation between domestic-European-rest of the world supply goods
p_m_initial(y,g)                        international price of the imported goods
p_ex_initial(y,g)                       international price of exported goods
p_q_initial(y,s)                        initial final price of the good produced by a specific sector
p_va_initial(y,s)                       initial value added composite good price of a specific sector
p_s_initial(y,s)                        initial selling price of the commodity (by the productive sector perspective)
p_d_initial(y,g)                        initial price of domestic supplied good
p_pf_initial(y,pf)                      initial production factor price
mu_cpi(y,g)                      %       weight of the good on the consumer price index
top_down_pollutants(sam,pollut)  SOx (Sulfur oxides per tonnes) - NOx (Nitrogen oxides per tonnes)- VOC (Volatile organic compounds excluding CH4 per tonnes) - CH4 (Methane per tonnes) - CO (arbon monoxide per tonnes) - NH3 (Ammonia per tonnes)
*- CO2 (Carbon dioxide per thousand tonnes) - SF6 (Sulfur hexaflouride per kg) - N2O (Nitrogen monoxide per tonnes) - PM10 (particles in susp diam up to 10 microm per tonnes) - PFC (Carbonated polyfluorene compounds per kg)
*- HFC (Hydroflouric carbon compounds per kg)
co2_emission_rights(y,ETS_s)     MMtCO2e Emission rights given by the government to the sector belonging to the Emission Trading System (ETS)
co2e_ets_sectors_emission(y,ets_s) MMtCO2e CO2 emission of each sector in the ETS
emission_rate(ey,s)              MMtCO2e:Q_S CO2e emission rate by sector
*Bottom-up generation parameters
load(ey,l,p,b)
init_oem_vom(y,t)                :MWh   operation and maintenance variable costs
init_oem_fom_labor(y,l,t)        :kW    operation and maintenance labor fixed costs
init_oem_fom_social_contribution(y,l,t) :kW operation and maintenance social contribution fixed costs
init_oem_fom_equipments(y,l,t)   :kW    operation and maintenance equipments fixed costs
thermodynamic_efficiency(y,t,f)  MWh:t
init_own_cons_gen_pctg           %       initial own consumption of electricity by the generation activity
init_own_cons_gen(y,l,p,b)
init_overnight_costs(y,t)        :KW    overnight new capacity investment costs
tdeo_losses_pctg(l,p,b)          %       proportion of losses in transmission and distribution by MWh produced
init_losses(y,l,p,b)
duration(l,p,b)                  hours   load block duration in a year (total in the year)
hours(l,p,b)                     hours   load block duration in a day (partial in a day)
pgenerated(y,l,p,b,t)            MW      generated potency by non dispatchable technologies
existent_installed_capacity(y,l,t) MW    power plant technology existent installed capacity
existent_installed_capacity_to_be_amortized(y,l,t) MW    Including exclusion of installed capacity previous liberalization (1997) considered already paid as stranded costs (results before 1998 dont have meaning)
demand(y,sam,l,p,b)              MW      electricity power demanded
fuel_price(y,t,f)                :t     fuel price: Enriched Uranium (:Kg) Coal (:t) Gas Natural (:miles m3) Fuel-oil (:t diesel)
pctg_fueloil_use_on_fg(y,l)      %       percentage of fuel-oil combustible used on FuelGas technology
pimported(y,l,p,b)               MW      generated potency imported
hydro_inflows(y,l,p,t)           MWh     hydroelectic run of river and reservoir inflows
pump_efficiency                  %       pumping technologies efficiency
res_max(y,l,t)                   MWh     maximum reservoir level
res_init(y,l,t)                  MWh     reservoir stored energy at the beginning of the year
availability_factor(y,l,t)       %       mean availability of technology
renewable_premium(y,t)           :MWh   technology renewable premium
pollutant_content(t,f,pollut)    10^6t:MWh (MMTCO2 - million metric tons of carbon dioxide) CO2 - 10^9g:MWh NOx and SOx and PM10
co2e_content_by_pollutant(co2e_pollut) p.u.   co2 equivalent by pollutant (MMtCO2e:MMt)
acid_equivalence_by_pollutant(acid_pollut) p.u. acid equivalent by pollutant (acid eq:g)
acid_equivalent_content(f,t)     acid equivalent pollution
*co2e_content(f,t)                MMtCO2e co2 emission
co2e_content(f,t)                tCO2e co2 emission
co2_price(y)                     :tCO2e co2 price
co2_emission_rights_assignment_GEN_technology(y,t) MMtCO2e Emission rights given by the government to the electricity producing technology
not_internittent_coverage_rate   %
idc(t)                           p.u.    (accumulated interest during construction)
capital_recovery_factor(t)       p.u.    (accumulated discount payments during amortization)
construction_time(t)             years   new capacity construction time by technology
power_plant_time_life(t)         years   power plant time life
init_oem_fom(y,t)                :KW    operation and maintenance fixed costs
years_of_amortization(t)         years   years of amortization of new capacity investments
MW_produced_by_1_gigacal(t,f)    KCAL:MWH power plant technology efficiency
cal_power_of_1_unit_of_fuel(t,f) GigaCAL:kg energy contained in combustible
interest_rate                    %       spain interest rate to borrow money for new capacity electricity investments
real_discount_rate               %       spain real discount rate to computation of the present value of the amortized investments
total_labor_expenditure(y,act)          total labor expenditure (wage and taxes) in each electricity activity (GEN and TDeO)
social_contribution_aliquot      %       social contribution aliquot under labor expenditure
tdeo_amortization_expenditure(y)        TDeO amortization expenditures
tdeo_new_investments(y)                 TDeO new investments
pctg_daily_market_on_energy_price(y) %   percentage of daily market on total energy price (energy price = daily market + intraday market)
K                                p.u.    index
init_fom(y,l,t)                  mill.  total operation and maintenance fixed costs
init_fom_labor(y,l,t)            mill.  total operation and maintenance labor fixed costs
init_fom_social_contribution(y,l,t) mill. total operation and maintenance social contribution fixed costs
init_fom_equipments(y,l,t)       mill.  total operation and maintenance equipments fixed costs
existent_installed_capacity_amortization(y,t,l) mill. (results before 1998 do not have meaning)
totaldemand(y,l,p,b)             MW      total demand excluding pumping consumption (sectors+institutions demand)
tx_rate(y,sam,tx)                %       Tax rate (production and product taxes)
tx_rate_sc(y,pf,s)               %       Social contribution tax rate
demand_growth /0.01/
* Demand response parameters
DR_penetration_level(y)          %       Demand response penetration level as a fraction of demand that is involved in DR programs (pu)
minimum_required_DR_savings(y)   %       Minimum percentage savings from which the customer is willing to shift its electricity load
app_use(y,app,l,p,b)             %       Fraction of total electricity household consumption in each hour for each appliance (pu)
app_conservation_potential(y,app) %      Conservation potential of each appliance load (pu)
households_load_growth_rate      %       Growth rate of electricity domestic demand
DR_dem(y,l,p,b)                  MW      Demand response available manageable demand
DR_app_use(y,app,l,p,b)          %       Manageable appliance load demand participating in demand management programs
displaceable_load(y,l,p,b)       MW      Total displaceable load
conservable_load(y,l,p,b)        MW      Total conservable load
GAD_energy_only_price(y,l,p,b)   :MWh   Base price to GAD displacement decision
Hyd_Res_stochastic_water_adjusted_availability(y,l,b,p) p.u. Adjust term for the amount of water available in the reservoir that can be used in the production (necessary to diminish the participation of water in the system profile flatening)
;


*---------Excel loading data------------------
$onecho > input.txt
i=Data.xlsx
r1=SAM!D6:U23
o1=SAM.inc
r2=Top-down!B6:B9;B16:B21;B33:B33;D6:J9;D16:J21;D33:J33
o2=Top-down.inc
r3=Top-down!B23:B26;D23:J26
o3=Top-down_scalar.inc
r4=Top-down!B39:D65;F39:M65
o4=top_down_pollutants.inc
r5=Bottom-up!B5:J269;L5:V269
o5=Bottom-up.inc
r6=Bottom-up!B271:J290;L271:W290
o6=Bottom-up_monthly.inc
r7=Bottom-up!B293:J345;L293:L345
o7=Bottom-up_scalar.inc
r8=Electricity_demand!B4:L148;N4:AL148
o8=Bottom-up_Household_Demand_Profile.inc
r9=Bottom-up_generation!B6:AA6;B8:AA8767
o9=Bottom-up_generation.inc
r10=Holidays!B5:F17
o10=Holidays.inc
r11=GAD!B7:H105;J7:P105
o11=GAD_app_use.inc
r12=GAD!B111:D118;F111:F118
o12=GAD_app_conservation_potential.inc
$offecho
$call =xls2gms @input.txt

*Parameters tables
table    SAM_table(*,*)
$include SAM.inc
;
table    Top_down(*,*)
$include Top-down.inc
;
table    Top_down_scalar(*,*)
$include Top-down_scalar.inc
;
table    top_down_pollutants_table(*,*,*)
$include top_down_pollutants.inc
;
table    Bottom_up(*,*,*,*,*,*)
$include Bottom-up.inc
;
table    Bottom_up_scalar(*,*,*,*,*,*)
$include Bottom-up_scalar.inc
;
table    Bottom_up_monthly_data(*,y,l,*,t,month)
$include Bottom-up_monthly.inc
;
table    Bottom_up_Household_Demand_Profile(*,y,l,daytype,weekday,month,hour)
$include Bottom-up_Household_Demand_Profile.inc
;
table    BU_generation_data(l,y,month,day,hour,*)
$include Bottom-up_generation.inc
;
set    Holidays(y,month,day) /
$include Holidays.inc
/;
table    GAD_app_use_table(*,*,*,hour,app)
$include GAD_app_use.inc
;
table    GAD_app_conservation_potential_table(*,*,*)
$include GAD_app_conservation_potential.inc
;
*Deleting Auxiliary Files
execute 'del input.txt SAM.inc, Top-down.inc, Top-down_scalar.inc, top_down_pollutants.inc, Bottom-up.inc, Bottom-up_scalar.inc, Bottom-up_monthly.inc, Bottom-up_Household_Demand_Profile.inc, Bottom-up_generation.inc, Holidays.inc, GAD_app_use.inc, GAD_app_conservation_potential.inc';

*-------------------------------------------------------------------------------
*--------------------------- Load Block Aggregation -----------------------------
*-------------------------------------------------------------------------------
*Auxiliar parameters and sets for load block definition
set BU_auxiliar_data_set / Imports, electricity_energy_only_price, Exports, PPumped, load, Households, Hyd_Res_stochasticity_availability  /;
set BU_monthly_auxiliar_data_set / hydro_inflows_by_hour /;
Set DaysWithData(month,day,hour);
loop((ey,l), DaysWithData(month,day,hour)$(BU_generation_data(l,ey,month,day,hour,"load"))=yes; );
set month_day_hour_daytype_weekday(month,day,hour,daytype,weekday);
set p_month_day_hour_daytype_weekday(p,month,day,hour,daytype,weekday);
set p_month_day_hour(p,month,day,hour);
set Winter(month) /january,february,march,october,november,december/;
set Summer(month) /april,may,june,july,august,september/;
parameters count, date,dow,currentyear, currentmonth, currentday, maxrank(l,p), BU_PGEN_aggregated_data(t,ey,l,p,b), BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b), duration(l,p,b),expanded_BU_monthly_data(BU_monthly_auxiliar_data_set,p,y,l,month,day,hour,t), aux_BU_generation_data(p,l,ey,month,day,hour), rank(p,ey,l,month,day,hour),expanded_GAD_app_use_data(l,p,month,day,hour,app), BU_aggregated_GAD_app_use(ey,app,l,p,b);

*Assigning Weekdays and Holidays
loop(ey,
loop(DaysWithData(month,day,hour),
         currentyear = ey.val;
         currentmonth = month.ord;
         currentday = day.val;
         date  = jdate(currentyear,currentmonth,currentday);
         dow    = gdow (date);
         if ((dow = 1), if (holidays(ey,month,day),      month_day_hour_daytype_weekday(month,day,hour,"Holiday","Monday") = yes;
                        else                             month_day_hour_daytype_weekday(month,day,hour,"Working","Monday") = yes;
                         );
                 );
         if ((dow = 2), if (holidays(ey,month,day),      month_day_hour_daytype_weekday(month,day,hour,"Holiday","Tuesday") = yes;
                        else                             month_day_hour_daytype_weekday(month,day,hour,"Working","Tuesday") = yes;
                         );
                 );
         if ((dow = 3), if (holidays(ey,month,day),      month_day_hour_daytype_weekday(month,day,hour,"Holiday","Wednesday") = yes;
                        else                             month_day_hour_daytype_weekday(month,day,hour,"Working","Wednesday") = yes;
                         );
                 );
         if ((dow = 4), if (holidays(ey,month,day),      month_day_hour_daytype_weekday(month,day,hour,"Holiday","Thursday") = yes;
                        else                             month_day_hour_daytype_weekday(month,day,hour,"Working","Thursday") = yes;
                         );
                 );
         if ((dow = 5), if (holidays(ey,month,day),      month_day_hour_daytype_weekday(month,day,hour,"Holiday","Friday") = yes;
                        else                             month_day_hour_daytype_weekday(month,day,hour,"Working","Friday") = yes;
                         );
                 );
         if ((dow = 6),                                  month_day_hour_daytype_weekday(month,day,hour,"Holiday","Saturday") = yes;
                 );
         if ((dow = 7),                                  month_day_hour_daytype_weekday(month,day,hour,"Holiday","Sunday") = yes;
                 );
);
);

*Assigning period
if((UseLoadBlockAggregation=1),
loop(p,
         p_month_day_hour_daytype_weekday(p,month,day,hour,daytype,weekday)$(load_segment_definition(p,month,daytype,weekday) and month_day_hour_daytype_weekday(month,day,hour,daytype,weekday)) = yes;
);
loop(p_month_day_hour_daytype_weekday(p,month,day,hour,daytype,weekday),
         p_month_day_hour(p,month,day,hour)=yes;
);
);

if((UseLoadBlockAggregation=0),
loop((p,month,day,hour)$DaysWithData(month,day,hour),
         if(ord(p)=ord(month),
         p_month_day_hour(p,month,day,hour)=yes;
);
);
);

*Assigning block
*avoiding same value to load in ranking the data
loop(p_month_day_hour(p,month,day,hour),
         aux_BU_generation_data(p,l,ey,month,day,hour)=BU_generation_data(l,ey,month,day,hour,"load")+(month.ord/1e2+day.val/1e4+hour.val/1e6)/1e3;
);

*calculating rank (referenced to period)
loop((p,ey,l),
         rank(p,ey,l,month,day,hour)$p_month_day_hour(p,month,day,hour) = sum((month_alias,day_alias,hour_alias)$(aux_BU_generation_data(p,l,ey,month_alias,day_alias,hour_alias) GE aux_BU_generation_data(p,l,ey,month,day,hour)), 1);
         );
maxrank(l,p)=  smax( (ey_alias,month_alias,day_alias,hour_alias), rank(p,ey_alias,l,month_alias,day_alias,hour_alias));

display rank,maxrank;

*loading GAD two season values
loop (p_month_day_hour(p,month,day,hour)$Winter(month),
         expanded_GAD_app_use_data(l,p,month,day,hour,app)=GAD_app_use_table("app_use",l,"Winter",hour,app);
     );

loop (p_month_day_hour(p,month,day,hour)$Summer(month),
         expanded_GAD_app_use_data(l,p,month,day,hour,app)=GAD_app_use_table("app_use",l,"Summer",hour,app);
     );

*assigning block values
loop((ey,l),
         loop(month_day_hour_daytype_weekday(month,day,hour,daytype,weekday),
                 BU_generation_data(l,ey,month,day,hour,"Households")=Bottom_up_Household_Demand_Profile("Household_Demand_Profile",ey,l,daytype,weekday,month,hour);
         );
);

*initializing parameters
BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b)=0;
BU_PGEN_aggregated_data(t,ey,l,p,b)=0;
BU_aggregated_GAD_app_use(ey,app,l,p,b)=0;
duration(l,p,b)=0;

if((UseLoadBlockAggregation=1),
         loop ((ey,l),
                 loop(p_month_day_hour(p,month,day,hour),
                         BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b)=BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b) + BU_generation_data(l,ey,month,day,hour,BU_auxiliar_data_set)$(  ((rank(p,ey,l,month,day,hour) le (100-Block_min_percentil(b))*(maxrank(l,p)/100))) and ((rank(p,ey,l,month,day,hour) > (100-Block_max_percentil(b))*(maxrank(l,p)/100))) );
                         BU_PGEN_aggregated_data(t,ey,l,p,b)=BU_PGEN_aggregated_data(t,ey,l,p,b) + BU_generation_data(l,ey,month,day,hour,t)$(  ((rank(p,ey,l,month,day,hour) le (100-Block_min_percentil(b))*(maxrank(l,p)/100))) and ((rank(p,ey,l,month,day,hour) > (100-Block_max_percentil(b))*(maxrank(l,p)/100))) );
                         BU_aggregated_GAD_app_use(ey,app,l,p,b) = BU_aggregated_GAD_app_use(ey,app,l,p,b) + expanded_GAD_app_use_data(l,p,month,day,hour,app)$(  ((rank(p,ey,l,month,day,hour) le (100-Block_min_percentil(b))*(maxrank(l,p)/100))) and ((rank(p,ey,l,month,day,hour) > (100-Block_max_percentil(b))*(maxrank(l,p)/100))) );
                         duration(l,p,b)=duration(l,p,b) + 1$(  ((rank(p,ey,l,month,day,hour) le (100-Block_min_percentil(b))*(maxrank(l,p)/100))) and ((rank(p,ey,l,month,day,hour) > (100-Block_max_percentil(b))*(maxrank(l,p)/100))) );

*                         BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b)=BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b) + BU_generation_data(l,ey,month,day,hour,BU_auxiliar_data_set)$( ( (maxrank(l,p)+1-rank(p,ey,l,month,day,hour)*(maxrank(l,p)/100)) < (Block_min_percentil(b)*(maxrank(l,p)/100))) and (maxrank(l,p)+1-rank(p,ey,l,month,day,hour) ge (Block_max_percentil(b)*(maxrank(l,p)/100))) );
*                         BU_aggregated_GAD_app_use(ey,app,l,p,b) = BU_aggregated_GAD_app_use(ey,app,l,p,b) + expanded_GAD_app_use_data(l,p,month,day,hour,app)$( (maxrank(l,p)+1-rank(p,ey,l,month,day,hour) < (Block_min_percentil(b)*(maxrank(l,p)/100))) and (maxrank(l,p)+1-rank(p,ey,l,month,day,hour) ge (Block_max_percentil(b)*(maxrank(l,p)/100))) );
*                         duration(l,p,b)=duration(l,p,b) + 1$( (maxrank(l,p)+1-rank(p,ey,l,month,day,hour) < (Block_min_percentil(b)*(maxrank(l,p)/100))) and (maxrank(l,p)+1-rank(p,ey,l,month,day,hour) ge (Block_max_percentil(b)*(maxrank(l,p)/100))) );
                 );
         );
);



if((UseLoadBlockAggregation=0),
         loop ((ey,l),
                 loop(p_month_day_hour(p,month,day,hour),
                         loop(b$( b.val=rank(p,ey,l,month,day,hour)),
                         BU_aggregated_data(BU_auxiliar_data_set,ey,l,p,b)=BU_generation_data(l,ey,month,day,hour,BU_auxiliar_data_set);
                         BU_PGEN_aggregated_data(t,ey,l,p,b)=BU_generation_data(l,ey,month,day,hour,t);
                         BU_aggregated_GAD_app_use(ey,app,l,p,b) = BU_aggregated_GAD_app_use(ey,app,l,p,b);
                         duration(l,p,b)=1;
                         );
                 );
         );
);

*Monthly data
loop(p_month_day_hour(p,month,day,hour),
         expanded_BU_monthly_data(BU_monthly_auxiliar_data_set,p,y,l,month,day,hour,t) = Bottom_up_monthly_data(BU_monthly_auxiliar_data_set,y,l,"na",t,month);
);


*Demand Response blocks
set Decrease_DR_Load_Blocks(l,p,b), Increase_DR_Load_Blocks(l,p,b);
loop (ey,
         loop((l,p,b)$duration(l,p,b),
                 if ( (BU_aggregated_data("load",ey,l,p,b)/duration(l,p,b)) > ( smax(b_alias$duration(l,p,b_alias), BU_aggregated_data("load",ey,l,p,b_alias)/duration(l,p,b_alias)) + smin(b_alias$duration(l,p,b_alias), BU_aggregated_data("load",ey,l,p,b_alias)/duration(l,p,b_alias)) )/2, Decrease_DR_Load_Blocks(l,p,b) = yes;
                 else                                                                                                                                                                  Increase_DR_Load_Blocks(l,p,b) = yes;
                 );
         );
);
display Decrease_DR_Load_Blocks, Increase_DR_Load_Blocks;


*--------------------------------------------------------------------------------
*---------------------- Assigning model parameters values -----------------------
*--------------------------------------------------------------------------------

*---------SAM parameters------------------
e_ii_s(samyear,g,s)=SAM_table(g,s);
e_pf_s(samyear,pf,s)=SAM_table(pf,s);
e_tx_sam(samyear,tx,sam)=SAM_table(tx,sam);
e_m_s(samyear,s)=SAM_table("Imports",s);
e_g_i(samyear,g,i)=SAM_table(g,i);
e_i_tx(samyear,i,tx)=SAM_table(i,tx);
e_transf_i(samyear,i,i2)=SAM_table(i,i2);
e_transf_k_i_ext(samyear,i)=SAM_table("Imports",i);
e_i_pf(samyear,i,pf)=SAM_table(i,pf);
e_i_sav(samyear,i)=SAM_table("Saves-Investments",i);
e_inv(samyear,g)=SAM_table(g,"Saves-Investments");
e_sav(samyear)=SAM_table("Saves-Investments","Exports");
e_g_ex(samyear,g)=SAM_table(g,"Exports");
e_transf_i_s(y,i,s)=-SAM_table(i,s);
e_transf_k_ext_i(samyear,i)=SAM_table(i,"Exports");
e_transf_k_ext_spain(samyear)=-SAM_table("Imports","Saves-Investments");

*---------Top-down parameters-------------
*Elasticities
elasticity_va(s)=Top_down("elasticity_VA",s);
elasticity_d(g)=Top_down("elasticity_D",g);
elasticity_q(g)=Top_down("elasticity_EX",g);
*Prices
p_m_initial(samyear,g)=Top_down("p_M",g);
p_ex_initial(samyear,g)=Top_down("p_EX",g);
p_q_initial(samyear,s)=Top_down("p_Q_initial",s);
p_va_initial(samyear,s)=Top_down("p_VA_initial",s);
p_s_initial(samyear,s)=Top_down("p_s_initial",s);
p_d_initial(samyear,g)=Top_down("p_D_initial",g);
p_pf_initial(samyear,"Labor")=Top_down_scalar("p_L_initial","Value");
p_pf_initial(samyear,"Capital")=Top_down_scalar("p_K_initial","Value");
mu_cpi(samyear,g)=Top_down("mu_cpi",g);
top_down_pollutants(sam,pollut)=top_down_pollutants_table("top_down_pollutants",pollut,sam);

*---------Bottom-up parameters------------
construction_time(t)=Bottom_up("construction_time","na","na","na","na",t);
power_plant_time_life(t)=Bottom_up("power_plant_time_life","na","na","na","na",t);
init_overnight_costs(y,t)=Bottom_up("init_overnight_costs","2005","na","na","na",t);
init_oem_vom(y,t)=Bottom_up("init_oem_vom","2005","na","na","na",t);
init_oem_fom(y,t)=Bottom_up("init_oem_fom","2005","na","na","na",t);
years_of_amortization(t)=Bottom_up("years_of_amortization","na","na","na","na",t);
renewable_premium(y,t)=Bottom_up("renewable_premium","2005","na","na","na",t);
res_max(y,l,t)=Bottom_up("res_max","2005",l,"na","na",t);
res_init("2005",l,t)=Bottom_up("res_init","2005",l,"na","na",t);
res_init(y,l,t)$(res_init(y,l,t)=0)=Bottom_up("res_init","2006",l,"na","na",t);
availability_factor(y,l,t)=Bottom_up("availability_factor","2005",l,"na","na",t);
MW_produced_by_1_gigacal(t,f)=Bottom_up("MW_produced_by_1_gigacal","na","na","na",f,t);
cal_power_of_1_unit_of_fuel(t,f)=Bottom_up("cal_power_of_1_unit_of_fuel","na","na","na",f,t);
fuel_price(y,t,f)=Bottom_up("fuel_price","2005","na","na",f,t);
existent_installed_capacity(y,l,t)=Bottom_up("existent_installed_capacity",y,l,"na","na",t);
interest_rate=Bottom_up_scalar("interest_rate","na","na","na","na","Value");
real_discount_rate=Bottom_up_scalar("real_discount_rate","na","na","na","na","Value");
co2_emission_rights(y,ets_s)=top_down_pollutants_table("CO2_emission_rights",y,ETS_s);
co2_emission_rights(y,ets_s)$(co2_emission_rights(y,ets_s)=0)=top_down_pollutants_table("CO2_emission_rights","others",ETS_s);
pollutant_content(t,f,pollut)=(Bottom_up("pollutant_content",pollut,"na","na",f,t)/1e6)$(sameas(pollut,"CO2"))+(Bottom_up("pollutant_content",pollut,"na","na",f,t)/1e9)$(sameas(pollut,"SOx") or sameas(pollut,"NOx") or sameas(pollut,"PM10"));
co2e_content_by_pollutant(co2e_pollut)=Bottom_up_scalar("co2e_content_by_pollutant",co2e_pollut,"na","na","na","Value");
acid_equivalence_by_pollutant(acid_pollut)=Bottom_up_scalar("acid_equivalence_by_pollutant",acid_pollut,"na","na","na","Value");
co2e_content(f,t)= sum(co2e_pollut, pollutant_content(t,f,co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))*1e6;
acid_equivalent_content(f,t)=sum(acid_pollut, pollutant_content(t,f,acid_pollut)*acid_equivalence_by_pollutant(acid_pollut));
co2e_ets_sectors_emission("2005",ets_s)= top_down_pollutants(ets_s,"CO2")/1e3*co2e_content_by_pollutant("CO2")+top_down_pollutants(ets_s,"CH4")/1e6*co2e_content_by_pollutant("CH4")+top_down_pollutants(ets_s,"N2O")/1e6*co2e_content_by_pollutant("N2O")+top_down_pollutants(ets_s,"SF6")/1e9*co2e_content_by_pollutant("SF6")+top_down_pollutants(ets_s,"HFC")/1e9*co2e_content_by_pollutant("HFC")+top_down_pollutants(ets_s,"PFC")/1e9*co2e_content_by_pollutant("PFC");
emission_rate(ey,ets_s)=co2e_ets_sectors_emission(ey,ets_s)/((sum(g,e_ii_s(ey,g,ets_s))+sum(pf,e_pf_s(ey,pf,ets_s))+ e_tx_sam(ey,"Social_Contributions",ets_s) + e_tx_sam(ey,"Product_Tax",ets_s)+e_tx_sam(ey,"CO2_Payments",ets_s)-sum(i,e_transf_i_s(ey,i,ets_s)))/p_s_initial(ey,ets_s));
co2_price(y)=Bottom_up_scalar("co2_price",y,"na","na","na","Value");
co2_price(y)$(co2_price(y)=0)=Bottom_up_scalar("co2_price","others","na","na","na","Value");
co2_emission_rights_assignment_GEN_technology(y,t)=Bottom_up("CO2_emission_rights_assignment_GEN_technology",y,"na","na","na",t);
pump_efficiency=Bottom_up_scalar("pump_efficiency","na","na","na","na","Value");
pctg_fueloil_use_on_fg(y,l)=Bottom_up_scalar("pctg_fueloil_use_on_fg",y,l,"na","na","Value");
pctg_fueloil_use_on_fg(y,l)$(pctg_fueloil_use_on_fg(y,l)=0)=Bottom_up_scalar("pctg_fueloil_use_on_fg","others",l,"na","na","Value");
init_own_cons_gen_pctg=Bottom_up_scalar("init_own_cons_gen_pctg","na","na","na","na","Value");
total_labor_expenditure(y,"TDeO")=Bottom_up_scalar("total_labor_expenditure",y,"na","TDeO","na","Value");
social_contribution_aliquot=e_tx_sam("2005","Social_Contributions","electricity")/e_pf_s("2005","Labor","electricity");
total_labor_expenditure(ey,"GEN")=(e_pf_s(ey,"Labor","electricity")+e_tx_sam("2005","Social_Contributions","electricity"))*10**6-total_labor_expenditure(ey,"TDeO");
tdeo_amortization_expenditure(y)=Bottom_up_scalar("tdeo_amortization_expenditure","2005","na","na","na","Value");
tdeo_new_investments(y)=Bottom_up_scalar("tdeo_new_investments","2005","na","na","na","Value");
pctg_daily_market_on_energy_price(y)=Bottom_up_scalar("pctg_daily_market_on_energy_price","2005","na","na","na","Value");
not_internittent_coverage_rate=Bottom_up_scalar("not_internittent_coverage_rate","na","na","na","na","Value");
tdeo_losses_pctg(l,p,b)$duration(l,p,b)=Bottom_up_scalar("tdeo_losses_pctg","na",l,"na","na","Value");
*fuel price unit conversion - Original: Enriched Uranium (:Kg) Coal (:t) Gas Natural (:MBtu) Fuel-oil (:barrel) - Final: Enriched Uranium (:Kg) Coal (:t) Gas Natural (:miles m3) Fuel-oil (:t diesel)
*Gas Natural (:MBtu) to Gas Natural (/miles m3)
fuel_price(y,t,"Natural_Gas") = fuel_price(y,t,"Natural_Gas") * 36.905;
*Fuel-oil (:barrel) to Fuel-oil (/t crude oil)
fuel_price(y,t,"Fuel-oil") = fuel_price(y,t,"Fuel-oil") * 7.33;
*Fuel-oil (/t crude oil) to Fuel-oil (/t diesel)
fuel_price(y,t,"Fuel-oil") = fuel_price(y,t,"Fuel-oil") * 1.01;
init_fom(y,l,t)=init_oem_fom("2005",t)*existent_installed_capacity("2005",l,t) / 1e3;
init_fom_labor(y,l,t)= (1-social_contribution_aliquot)*total_labor_expenditure("2005","GEN")/1e6 * ( init_fom(y,l,t)/sum(t_alias, init_fom(y,l,t_alias)) );
init_fom_social_contribution(y,l,t)= social_contribution_aliquot*total_labor_expenditure("2005","GEN")/1e6 * ( init_fom(y,l,t)/sum(t_alias, init_fom(y,l,t_alias)) );
init_fom_equipments(y,l,t)= init_fom(y,l,t) - init_fom_labor(y,l,t) - init_fom_social_contribution(y,l,t);
init_oem_fom_labor(y,l,t)$existent_installed_capacity(y,l,t)=init_fom_labor(y,l,t)*1e3/existent_installed_capacity(y,l,t);
init_oem_fom_social_contribution(y,l,t)$existent_installed_capacity(y,l,t)=init_fom_social_contribution(y,l,t)*1e3/existent_installed_capacity(y,l,t);
init_oem_fom_equipments(y,l,t)$existent_installed_capacity(y,l,t)=init_fom_equipments(y,l,t)*1e3/existent_installed_capacity(y,l,t);
thermodynamic_efficiency(y,t,f)$thermal_t(t,f)=MW_produced_by_1_gigacal(t,f)/(cal_power_of_1_unit_of_fuel(t,f)*1e3);
loop(ey, Hyd_Res_stochastic_water_adjusted_availability(eys,l,b,p)$duration(l,p,b) = BU_aggregated_data("Hyd_Res_stochasticity_availability",ey,l,p,b)/duration(l,p,b); );

*---------Bottom-up load block dependable parameters------------
load(ey,l,p,b)$duration(l,p,b)=BU_aggregated_data("load",ey,l,p,b)/duration(l,p,b);
hydro_inflows(y,l,p,t) = sum((month,day,hour)$p_month_day_hour(p,month,day,hour), expanded_BU_monthly_data("hydro_inflows_by_hour",p,y,l,month,day,hour,t));
set years_with_inflow_data(y);
loop((l,p,t), years_with_inflow_data(eys)$(hydro_inflows(eys,l,p,t))=yes; );
hydro_inflows(eys,l,p,t)$(not years_with_inflow_data(eys))=sum(years_with_inflow_data,hydro_inflows(years_with_inflow_data,l,p,t))/sum(years_with_inflow_data,1);
pgenerated(ey,l,p,b,t)$duration(l,p,b)=BU_PGEN_aggregated_data(t,ey,l,p,b)/duration(l,p,b);
pimported(ey,l,p,b)$duration(l,p,b)=BU_aggregated_data("Imports",ey,l,p,b)/duration(l,p,b);
demand(ey,"Exports",l,p,b)$duration(l,p,b)=BU_aggregated_data("Exports",ey,l,p,b)/duration(l,p,b);
demand(ey,"households",l,p,b)$duration(l,p,b)=BU_aggregated_data("households",ey,l,p,b)/duration(l,p,b);
init_own_cons_gen(ey,l,p,b)=init_own_cons_gen_pctg*sum(t,pgenerated(ey,l,p,b,t));
init_losses(ey,l,p,b)=tdeo_losses_pctg(l,p,b)*( sum(t,pgenerated(ey,l,p,b,t)) + pimported(ey,l,p,b) - BU_aggregated_data("PPumped",ey,l,p,b)/duration(l,p,b) + demand(ey,"Exports",l,p,b) );
demand(ey,"electricity",l,p,b)$duration(l,p,b)= init_own_cons_gen(ey,l,p,b) + init_losses(ey,l,p,b) + BU_aggregated_data("PPumped",ey,l,p,b)/duration(l,p,b);
loop(sne, demand(ey,sne,l,p,b)$duration(l,p,b)=(SAM_table("electricity",sne)/sum(sne_alias, SAM_table("electricity",sne_alias)))*(load(ey,l,p,b)-demand(ey,"electricity",l,p,b)-demand(ey,"households",l,p,b)-demand(ey,"Exports",l,p,b)); );
loop ((eys)$(eys.val gt 2005), demand(eys,sam,l,p,b)= demand("2005",sam,l,p,b)*((1 + demand_growth)**(eys.val - 2005)); );

*---------existent_installed_capacity_to_be_amortized------------
*Liberalization of the market in 1997
*Existence of stranded costs - new liberalizaded market is insuficient to recover the anterior non amortized capacity installed - stranded costs estimated at 10177 m (revised to 8664 m)
*Solution: consider all installed capacity before 1998 already amortized. Solution to the model, consider all the years before 1997 with the same 1997 installed capacity
loop ((y)$(y.val lt 1997), existent_installed_capacity(y,l,t)=existent_installed_capacity("1997",l,t); );
loop((y,t), existent_installed_capacity_to_be_amortized(y,l,t)=(existent_installed_capacity(y,l,t)-existent_installed_capacity(y-years_of_amortization(t),l,t)); );
existent_installed_capacity_to_be_amortized(y,l,t)$(existent_installed_capacity_to_be_amortized(y,l,t)<0)=0;

*---------amortization------------
*initializing IDC
IDC(t)=0;
*IDC calculation
loop (t, K=1; loop ( y$(ord(y) le construction_time(t)),  IDC(t) = IDC(t)+(1/construction_time(t))*((1+interest_rate)**(construction_time(t)-K+1)); K = K + 1; ); );
*capital recovery factor calculation
capital_recovery_factor(t)=( real_discount_rate*((1+real_discount_rate)**years_of_amortization(t)) ) / (((1+real_discount_rate)**years_of_amortization(t))-1);
existent_installed_capacity_amortization(eys,t,l) = init_overnight_costs(eys,t) * IDC(t) * capital_recovery_factor(t) *  ( existent_installed_capacity_to_be_amortized(eys,l,t) )/1e3;

*---------tax rate------------
tx_rate_sc(ey,"Labor",s)= e_tx_sam(ey,"Social_Contributions",s)/e_pf_s(ey,"Labor",s);
tx_rate(ey,s,"Production_Taxes")= e_tx_sam(ey,"Production_Taxes",s)/(sum(g,e_ii_s(ey,g,s))+sum(pf,e_pf_s(ey,pf,s))+ e_tx_sam(ey,"Social_Contributions",s) + e_tx_sam(ey,"Product_Tax",s)+e_tx_sam(ey,"CO2_Payments",s)-sum(i,e_transf_i_s(ey,i,s)));
tx_rate(ey,sam,"Product_Tax")= (e_tx_sam(ey,"Product_Tax",sam)/sum(g,SAM_table(g,sam)))$(sum(g,SAM_table(g,sam))<>0);

*---------Demand Response------------
* Segn una encuesta del EEI, el 70% de los consumidores domsticos estara dispuesto a desplazar su carga por un ahorro del 5%
DR_penetration_level(y)=1;
*0.7;
minimum_required_DR_savings(y)=0.05;
*0.05;
loop(ey, app_use(y,app,l,p,b)$duration(l,p,b)=BU_aggregated_GAD_app_use(ey,app,l,p,b)/duration(l,p,b); );
app_conservation_potential(y,app)=GAD_app_conservation_potential_table("app_conservation_potential",app,"Value");
households_load_growth_rate = demand_growth;
DR_dem(y,l,p,b) = DR_penetration_level(y) * demand(y,"Households",l,p,b) * (1 + households_load_growth_rate)**(ord(p)-1);
DR_app_use(y,app,l,p,b) =  DR_dem(y,l,p,b)*app_use(y,app,l,p,b);
displaceable_load(y,l,p,b) = sum( app_displ, DR_app_use(y,app_displ,l,p,b) * app_conservation_potential(y,app_displ));
conservable_load(y,l,p,b) = sum( app_reduc, DR_app_use(y,app_reduc,l,p,b) * app_conservation_potential(y,app_reduc));
*parameter initialization
GAD_energy_only_price(y,l,p,b)=0;




parameter initial_prop_export_energy_only_price /1/, initial_prop_import_energy_only_price /1/, initial_pf_pct_adj(pf);
initial_pf_pct_adj(pf)=1;

*auxiliar parameter for initial bottom-up values
parameters first_init_oem_vom(y,t),first_init_oem_fom_labor(y,l,t),first_init_oem_fom_social_contribution(y,l,t),first_init_oem_fom_equipments(y,l,t),first_thermodynamic_efficiency(y,t,f),first_init_own_cons_gen_pctg,first_init_overnight_costs(y,t),first_tdeo_losses_pctg(l,p,b),first_exp_price_pctg,first_imp_price_pctg,first_tdeo_pf_pct_adj(pf),first_co2e_content(f,t);

*auxiliar parameters for results evaluation of iterastive SAM disaggregation
parameters max_deviation(iterations), oem_vom_dev(iterations), oem_fom_labor_dev(iterations), oem_fom_social_contribution_dev(iterations), oem_fom_equipments_dev(iterations), thermodynamic_efficiency_dev(iterations), own_cons_gen_pctg_dev(iterations), overnight_costs_dev(iterations), tdeo_losses_pctg_dev(iterations),exp_price_pctg_dev(iterations),imp_price_pctg_dev(iterations),tdeo_pf_pct_adj_dev(iterations),co2e_content_dev(iterations);
parameters  total_oem_vom_dev(iterations), total_oem_fom_labor_dev(iterations), total_oem_fom_social_contribution_dev(iterations), total_oem_fom_equipments_dev(iterations), total_thermodynamic_efficiency_dev(iterations), total_own_cons_gen_pctg_dev(iterations), total_overnight_costs_dev(iterations), total_tdeo_losses_pctg_dev(iterations),total_exp_price_pctg_dev(iterations),total_imp_price_pctg_dev(iterations),total_tdeo_pf_pct_adj_dev(iterations),total_co2e_content_dev(iterations), average_oem_vom_dev(iterations), average_oem_fom_labor_dev(iterations), average_oem_fom_social_contribution_dev(iterations), average_oem_fom_equipments_dev(iterations), average_thermodynamic_efficiency_dev(iterations), average_own_cons_gen_pctg_dev(iterations), average_overnight_costs_dev(iterations),average_tdeo_losses_pctg_dev(iterations),average_exp_price_pctg_dev(iterations),average_imp_price_pctg_dev(iterations),average_tdeo_pf_pct_adj_dev(iterations),average_co2e_content_dev(iterations), concentration_oem_vom_dev(iterations), concentration_oem_fom_labor_dev(iterations), concentration_oem_fom_social_contribution_dev(iterations), concentration_oem_fom_equipments_dev(iterations), concentration_thermodynamic_efficiency_dev(iterations), concentration_own_cons_gen_pctg_dev(iterations), concentration_overnight_costs_dev(iterations),concentration_tdeo_losses_pctg_dev(iterations),concentration_exp_price_pctg_dev(iterations),concentration_imp_price_pctg_dev(iterations),concentration_tdeo_pf_pct_adj_dev(iterations),concentration_co2e_content_dev(iterations);

*saving initial BU paremeters for ex-post evaluation of calibration
first_init_oem_vom(y,t)=init_oem_vom(y,t);
first_init_oem_fom_labor(y,l,t)=init_oem_fom_labor(y,l,t);
first_init_oem_fom_social_contribution(y,l,t)=init_oem_fom_social_contribution(y,l,t);
first_init_oem_fom_equipments(y,l,t)=init_oem_fom_equipments(y,l,t);
first_thermodynamic_efficiency(y,t,f)=thermodynamic_efficiency(y,t,f);
first_init_own_cons_gen_pctg=init_own_cons_gen_pctg;
first_init_overnight_costs(y,t)=init_overnight_costs(y,t);
first_tdeo_losses_pctg(l,p,b)=tdeo_losses_pctg(l,p,b);
first_exp_price_pctg=initial_prop_export_energy_only_price;
first_imp_price_pctg=initial_prop_import_energy_only_price;
first_tdeo_pf_pct_adj(pf)=initial_pf_pct_adj(pf);
first_co2e_content(f,t)=co2e_content(f,t);

display first_init_oem_vom,first_init_oem_fom_labor,first_init_oem_fom_social_contribution
first_init_oem_fom_equipments,first_thermodynamic_efficiency,first_init_own_cons_gen_pctg,
first_init_overnight_costs,first_tdeo_losses_pctg,first_exp_price_pctg,
first_imp_price_pctg,first_tdeo_pf_pct_adj,first_co2e_content;



