$Title Sets Definition
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         Hybrid Top-down Computable General Equilibrium and Bottom-up Electricity Expansion Model
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 10, oct, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext

*-------------------------------------------------------------------------------
*-------------------------------- Defining Macros ------------------------------
*-------------------------------------------------------------------------------

*-----------SENDING OPTIMIZATION RESULTS AS PARAMETERS TO THE FOLLOWING MODEL

$macro   CGE_scale_parameters(operator)  initial_Q_H_D_CGE(ey,g)=initial_Q_H_D_CGE(ey,g) &operator scale_factor; \
                                         initial_Y_H_CGE(ey)=initial_Y_H_CGE(ey) &operator scale_factor; \
                                         initial_Q_PF_CGE(ey,pf,s)=initial_Q_PF_CGE(ey,pf,s) &operator scale_factor; \
                                         initial_Q_VA_CGE(ey,s)=initial_Q_VA_CGE(ey,s) &operator scale_factor; \
                                         initial_Q_II_CGE(ey,g,s)=initial_Q_II_CGE(ey,g,s) &operator scale_factor; \
                                         initial_Q_S_CGE(ey,s)=initial_Q_S_CGE(ey,s) &operator scale_factor; \
                                         initial_Q_M_CGE(ey,g)=initial_Q_M_CGE(ey,g) &operator scale_factor; \
                                         initial_Q_D_CGE(ey,g)=initial_Q_D_CGE(ey,g) &operator scale_factor; \
                                         initial_Q_EX_CGE(ey,g)=initial_Q_EX_CGE(ey,g) &operator scale_factor; \
                                         initial_Q_Q_CGE(ey,g)=initial_Q_Q_CGE(ey,g) &operator scale_factor; \
                                         initial_Y_G_CGE(ey)=initial_Y_G_CGE(ey) &operator scale_factor; \
                                         initial_E_G_CGE(ey)=initial_E_G_CGE(ey) &operator scale_factor; \
                                         initial_Y_TAX_CGE(ey)=initial_Y_TAX_CGE(ey) &operator scale_factor; \
                                         initial_S_TOTAL_H_CGE(ey)=initial_S_TOTAL_H_CGE(ey) &operator scale_factor; \
                                         initial_S_TOTAL_G_CGE(ey)=initial_S_TOTAL_G_CGE(ey) &operator scale_factor; \
                                         initial_S_TOTAL_EXT_CGE(ey)=initial_S_TOTAL_EXT_CGE(ey) &operator scale_factor; \
                                         initial_S_TOTAL_CGE(ey)=initial_S_TOTAL_CGE(ey) &operator scale_factor; \
                                         initial_Q_I_D_CGE(ey,g)=initial_Q_I_D_CGE(ey,g) &operator scale_factor; \
                                         initial_I_TOTAL_CGE(ey)=initial_I_TOTAL_CGE(ey) &operator scale_factor; \
                                         q_i_pf(ey,i,pf)=q_i_pf(ey,i,pf) &operator scale_factor; \
                                         q_gov_initial(ey,g)=q_gov_initial(ey,g) &operator scale_factor; \
                                         transf_g_h(ey)=transf_g_h(ey) &operator scale_factor; \
                                         transf_ext_g(ey)=transf_ext_g(ey) &operator scale_factor; \
                                         transf_ext_h(ey)=transf_ext_h(ey) &operator scale_factor; \
                                         transf_ext_k(ey)=transf_ext_k(ey) &operator scale_factor; \
                                         e_transf_i_s(ey,i,s)=e_transf_i_s(ey,i,s) &operator scale_factor;

$macro   CGE_scale_results(operator)     Q_H_D_CGE.l(ey,g)=Q_H_D_CGE.l(ey,g) &operator scale_factor; \
                                         Y_H_CGE.l(ey)=Y_H_CGE.l(ey) &operator scale_factor; \
                                         Q_PF_LABOR_CGE.l(ey,s)=Q_PF_LABOR_CGE.l(ey,s) &operator scale_factor; \
                                         Q_PF_CAPITAL_CGE.l(ey,s)=Q_PF_CAPITAL_CGE.l(ey,s) &operator scale_factor; \
                                         Q_VA_CGE.l(ey,s)=Q_VA_CGE.l(ey,s) &operator scale_factor; \
                                         Q_II_CGE.l(ey,g,s)=Q_II_CGE.l(ey,g,s) &operator scale_factor; \
                                         Q_S_CGE.l(ey,s)=Q_S_CGE.l(ey,s) &operator scale_factor; \
                                         Q_M_CGE.l(ey,g)=Q_M_CGE.l(ey,g) &operator scale_factor; \
                                         Q_D_CGE.l(ey,g)=Q_D_CGE.l(ey,g) &operator scale_factor; \
                                         Q_EX_CGE.l(ey,g)=Q_EX_CGE.l(ey,g) &operator scale_factor; \
                                         Q_Q_CGE.l(ey,g)=Q_Q_CGE.l(ey,g) &operator scale_factor; \
                                         Y_G_CGE.l(ey)=Y_G_CGE.l(ey) &operator scale_factor; \
                                         E_G_CGE.l(ey)=E_G_CGE.l(ey) &operator scale_factor; \
                                         Y_TAX_CGE.l(ey)=Y_TAX_CGE.l(ey) &operator scale_factor; \
                                         S_TOTAL_CGE.l(ey)=S_TOTAL_CGE.l(ey) &operator scale_factor; \
                                         S_TOTAL_H_CGE.l(ey)=S_TOTAL_H_CGE.l(ey) &operator scale_factor; \
                                         S_TOTAL_G_CGE.l(ey)=S_TOTAL_G_CGE.l(ey) &operator scale_factor; \
                                         S_TOTAL_EXT_CGE.l(ey)=S_TOTAL_EXT_CGE.l(ey) &operator scale_factor; \
                                         I_TOTAL_CGE.l(ey)=I_TOTAL_CGE.l(ey) &operator scale_factor; \
                                         Q_I_D_CGE.l(ey,g)=Q_I_D_CGE.l(ey,g) &operator scale_factor;


$macro   CGE_results(execution)          parameters Q_H_D_CGE_&execution(ey,g),P_PF_LABOR_CGE_&execution(ey),P_PF_CAPITAL_CGE_&execution(ey),Y_H_CGE_&execution(ey),Q_PF_LABOR_CGE_&execution(ey,s),Q_PF_CAPITAL_CGE_&execution(ey,s),Q_VA_CGE_&execution(ey,s),P_VA_CGE_&execution(ey,s),Q_II_CGE_&execution(ey,g,s),Q_S_CGE_&execution(ey,s),P_S_CGE_&execution(ey,g),Q_M_CGE_&execution(ey,g),Q_D_CGE_&execution(ey,g),P_D_CGE_&execution(ey,g),Q_EX_CGE_&execution(ey,g),Q_Q_CGE_&execution(ey,g),P_Q_CGE_&execution(ey,g),Y_G_CGE_&execution(ey),E_G_CGE_&execution(ey),Y_TAX_CGE_&execution(ey),S_TOTAL_CGE_&execution(ey),S_TOTAL_H_CGE_&execution(ey),S_TOTAL_G_CGE_&execution(ey),S_TOTAL_EXT_CGE_&execution(ey),I_TOTAL_CGE_&execution(ey),Q_I_D_CGE_&execution(ey,g),CPI_CGE_&execution(ey),pollutants_CGE_&execution(ey,sam,pollut),total_pollutants_CGE_&execution(ey,pollut), total_co2e_CGE_&execution(ey), total_acid_equivalent_CGE_&execution(ey); \
                                         Q_H_D_CGE_&execution(ey,g)=Q_H_D_CGE.l(ey,g)*scale_factor; \
                                         P_PF_LABOR_CGE_&execution(ey)=P_PF_LABOR_CGE.l(ey); \
                                         P_PF_CAPITAL_CGE_&execution(ey)=P_PF_CAPITAL_CGE.l(ey); \
                                         Y_H_CGE_&execution(ey)=Y_H_CGE.l(ey)*scale_factor; \
                                         Q_PF_LABOR_CGE_&execution(ey,s)=Q_PF_LABOR_CGE.l(ey,s)*scale_factor; \
                                         Q_PF_CAPITAL_CGE_&execution(ey,s)=Q_PF_CAPITAL_CGE.l(ey,s)*scale_factor; \
                                         Q_VA_CGE_&execution(ey,s)=Q_VA_CGE.l(ey,s)*scale_factor; \
                                         P_VA_CGE_&execution(ey,s)=P_VA_CGE.l(ey,s); \
                                         Q_II_CGE_&execution(ey,g,s)=Q_II_CGE.l(ey,g,s)*scale_factor; \
                                         Q_S_CGE_&execution(ey,s)=Q_S_CGE.l(ey,s)*scale_factor; \
                                         P_S_CGE_&execution(ey,g)=P_S_CGE.l(ey,g); \
                                         Q_M_CGE_&execution(ey,g)=Q_M_CGE.l(ey,g)*scale_factor; \
                                         Q_D_CGE_&execution(ey,g)=Q_D_CGE.l(ey,g)*scale_factor; \
                                         P_D_CGE_&execution(ey,g)=P_D_CGE.l(ey,g); \
                                         Q_EX_CGE_&execution(ey,g)=Q_EX_CGE.l(ey,g)*scale_factor; \
                                         Q_Q_CGE_&execution(ey,g)=Q_Q_CGE.l(ey,g)*scale_factor; \
                                         P_Q_CGE_&execution(ey,g)=P_Q_CGE.l(ey,g); \
                                         Y_G_CGE_&execution(ey)=Y_G_CGE.l(ey)*scale_factor; \
                                         E_G_CGE_&execution(ey)=E_G_CGE.l(ey)*scale_factor; \
                                         Y_TAX_CGE_&execution(ey)=Y_TAX_CGE.l(ey)*scale_factor; \
                                         S_TOTAL_CGE_&execution(ey)=S_TOTAL_CGE.l(ey)*scale_factor; \
                                         S_TOTAL_H_CGE_&execution(ey)=S_TOTAL_H_CGE.l(ey)*scale_factor; \
                                         S_TOTAL_G_CGE_&execution(ey)=S_TOTAL_G_CGE.l(ey)*scale_factor; \
                                         S_TOTAL_EXT_CGE_&execution(ey)=S_TOTAL_EXT_CGE.l(ey)*scale_factor; \
                                         I_TOTAL_CGE_&execution(ey)=I_TOTAL_CGE.l(ey)*scale_factor; \
                                         Q_I_D_CGE_&execution(ey,g)=Q_I_D_CGE.l(ey,g)*scale_factor; \
                                         CPI_CGE_&execution(ey)=CPI_CGE.l(ey); \
                                         pollutants_CGE_&execution(ey,s,pollut)=top_down_pollutants(s,pollut)*( Q_S_CGE.l(ey,s) / initial_Q_S_CGE(ey,s) ); \
                                         pollutants_CGE_&execution(ey,"Households",pollut)=top_down_pollutants("Households",pollut)*( sum(g, Q_H_D_CGE.l(ey,g)*P_Q_CGE.l(ey,g)) / sum(g, initial_Q_H_D_CGE(ey,g)*initial_P_Q_CGE(ey,g)) ); \
                                         total_pollutants_CGE_&execution(ey,pollut)=sum(s, pollutants_CGE_&execution(ey,s,pollut)) + pollutants_CGE_&execution(ey,"Households",pollut); \
                                         total_co2e_CGE_&execution(ey)=sum(co2e_pollut, (total_pollutants_CGE_&execution(ey,co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CO2")) + (total_pollutants_CGE_&execution(ey,co2e_pollut)*1e3*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CH4") or sameas(co2e_pollut,"N2O")) +  (total_pollutants_CGE_&execution(ey,co2e_pollut)*1e6*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"SF6") or sameas(co2e_pollut,"HFC") or sameas(co2e_pollut,"PFC")) ); \
                                         total_acid_equivalent_CGE_&execution(ey)=sum(acid_pollut, total_pollutants_CGE_&execution(ey,acid_pollut)*acid_equivalence_by_pollutant(acid_pollut)); \



$macro  CGE_results_comparison           comparison_vector(P_PF_LABOR_CGE,ey) \
                                         comparison_vector(P_PF_CAPITAL_CGE,ey) \
                                         comparison_vector(Y_H_CGE,ey) \
                                         comparison_vector(Y_G_CGE,ey) \
                                         comparison_vector(E_G_CGE,ey) \
                                         comparison_vector(Y_TAX_CGE,ey) \
                                         comparison_vector(S_TOTAL_CGE,ey) \
                                         comparison_vector(S_TOTAL_H_CGE,ey) \
                                         comparison_vector(S_TOTAL_G_CGE,ey) \
                                         comparison_vector(S_TOTAL_EXT_CGE,ey) \
                                         comparison_vector(I_TOTAL_CGE,ey) \
                                         comparison_vector(CPI_CGE,ey) \
                                         comparison_two_dimensions(Q_H_D_CGE,ey,g) \
                                         comparison_two_dimensions(Q_PF_LABOR_CGE,ey,s) \
                                         comparison_two_dimensions(Q_PF_CAPITAL_CGE,ey,s) \
                                         comparison_two_dimensions(Q_VA_CGE,ey,s) \
                                         comparison_two_dimensions(P_VA_CGE,ey,s) \
                                         comparison_two_dimensions(Q_S_CGE,ey,s) \
                                         comparison_two_dimensions(P_S_CGE,ey,g) \
                                         comparison_two_dimensions(Q_M_CGE,ey,g) \
                                         comparison_two_dimensions(Q_D_CGE,ey,g) \
                                         comparison_two_dimensions(Q_EX_CGE,ey,g) \
                                         comparison_two_dimensions(Q_Q_CGE,ey,g) \
                                         comparison_two_dimensions(P_Q_CGE,ey,g) \
                                         comparison_two_dimensions(Q_I_D_CGE,ey,g) \
                                         comparison_three_dimensions(Q_II_CGE,ey,g,s) \
                                         comparison_three_dimensions(pollutants_CGE,ey,s,pollut) \
                                         comparison_two_dimensions(total_pollutants_CGE,ey,pollut) \
                                         comparison_vector(total_co2e_CGE,ey) \
                                         comparison_vector(total_acid_equivalent_CGE,ey)


$macro   Send_Results_LEGEN_to_SAMDIS    energy_only_price_SAMDIS(eys,l,p,b)$duration(l,p,b)=eq_demand_balance_case_study.m(eys,l,p,b)/duration(l,p,b)*1e6; \
                                         pgen_SAMDIS(eys,t,f,l,p,b)=PGEN_LEGEN.l(eys,t,f,l,p,b); \
                                         ppumped_SAMDIS(eys,l,p,b)=PPUMPED_LEGEN.l(eys,l,p,b); \
                                         BU_mkt_surplus(eys,l,p,b)= ( energy_only_price_SAMDIS(eys,l,p,b)*( demand(eys,"households",l,p,b) + sum(sne, demand(eys,sne,l,p,b)) + demand(eys,"Exports",l,p,b) - pimported(eys,l,p,b) ) )/1e6 - exec_fc*(sum((t,f)$thermal_t(t,f), FUEL_COST_LEGEN.l(eys,t,f,l,p,b))) - exec_co2*(sum((t,f)$emitting_t(t,f), CO2_PAYMENTS_LEGEN.l(eys,t,f,l,p,b))) - exec_vom*(sum((t,f)$t_f(t,f), VOM_LEGEN.l(eys,t,f,l,p,b))) + exec_renew_prem*(sum((t,f)$renewable_premium_t(t,f), PGEN_LEGEN.l(eys,t,f,l,p,b)*renewable_premium(eys,t)/1e6)); \
                                         BU_dist_factor(eys,l,p,b)$duration(l,p,b)= (BU_mkt_surplus(eys,l,p,b)) / sum((gp_alias,gb_alias)$duration(l,gp_alias,gb_alias), BU_mkt_surplus(eys,l,gp_alias,gb_alias)*duration(l,gp_alias,gb_alias)); \
                                         BU_market_failures_and_non_accounted_costs(eys,l,p,b)= BU_mkt_surplus(eys,l,p,b) - BU_dist_factor(eys,l,p,b)*duration(l,p,b)*(exec_oem_labor*(sum((t), init_oem_fom_labor(eys,l,t)*INSTALLED_CAPACITY_LEGEN.l(eys,l,t) / 1e3))- exec_oem_sc*(sum((t), init_oem_fom_social_contribution(eys,l,t)*INSTALLED_CAPACITY_LEGEN.l(eys,l,t) / 1e3))- exec_oem_equip*(sum((t), init_oem_fom_equipments(eys,l,t)*INSTALLED_CAPACITY_LEGEN.l(eys,l,t) / 1e3))- exec_capac*(sum((t), AMORTIZATION_LEGEN.l(eys,l,t)))+ exec_emiss_rights*( co2_emission_rights(eys,"Electricity")*co2_price(eys) ));

$macro   Send_Results_LEGEN_BAU_to_SAMDIS energy_only_price_SAMDIS(eys,l,p,b)$duration(l,p,b)=eq_demand_balance_bau.m(eys,l,p,b)/duration(l,p,b)*1e6; \
                                         pgen_SAMDIS(eys,t,f,l,p,b)=PGEN_LEGEN.l(eys,t,f,l,p,b); \
                                         ppumped_SAMDIS(eys,l,p,b)=PPUMPED_LEGEN.l(eys,l,p,b); \
                                         BU_mkt_surplus(eys,l,p,b)= ( energy_only_price_SAMDIS(eys,l,p,b)*( demand(eys,"households",l,p,b) + sum(sne, demand(eys,sne,l,p,b)) + demand(eys,"Exports",l,p,b) - pimported(eys,l,p,b) ) )/1e6 - exec_fc*(sum((t,f)$thermal_t(t,f), FUEL_COST_LEGEN.l(eys,t,f,l,p,b))) - exec_co2*(sum((t,f)$emitting_t(t,f), CO2_PAYMENTS_LEGEN.l(eys,t,f,l,p,b))) - exec_vom*(sum((t,f)$t_f(t,f), VOM_LEGEN.l(eys,t,f,l,p,b))) + exec_renew_prem*(sum((t,f)$renewable_premium_t(t,f), PGEN_LEGEN.l(eys,t,f,l,p,b)*renewable_premium(eys,t)/1e6)); \
                                         BU_dist_factor(eys,l,p,b)$duration(l,p,b)= (BU_mkt_surplus(eys,l,p,b)) / sum((gp_alias,gb_alias)$duration(l,gp_alias,gb_alias), BU_mkt_surplus(eys,l,gp_alias,gb_alias)*duration(l,gp_alias,gb_alias)); \
                                         BU_market_failures_and_non_accounted_costs(eys,l,p,b)= BU_mkt_surplus(eys,l,p,b) - BU_dist_factor(eys,l,p,b)*duration(l,p,b)*(exec_oem_labor*(sum((t), init_oem_fom_labor(eys,l,t)*INSTALLED_CAPACITY_LEGEN.l(eys,l,t) / 1e3))- exec_oem_sc*(sum((t), init_oem_fom_social_contribution(eys,l,t)*INSTALLED_CAPACITY_LEGEN.l(eys,l,t) / 1e3))- exec_oem_equip*(sum((t), init_oem_fom_equipments(eys,l,t)*INSTALLED_CAPACITY_LEGEN.l(eys,l,t) / 1e3))- exec_capac*(sum((t), AMORTIZATION_LEGEN.l(eys,l,t)))+ exec_emiss_rights*( co2_emission_rights(eys,"Electricity")*co2_price(eys) ));

$macro   Send_Results_SAMDIS_to_GEMED    parameters electricity_mk_failures_profits_and_non_accounted_costs(y,l,p,b); \
                                         electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b)=MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b);

$macro   Send_Results_SAMDIS_to_LEGEN    init_oem_vom(y,t)=sum(ey,OEM_VOM_SAMDIS.l(ey,t)); \
                                         init_oem_fom_labor(y,l,t)=sum(ey,OEM_FOM_LABOR_SAMDIS.l(ey,l,t)); \
                                         init_oem_fom_social_contribution(y,l,t)=sum(ey,OEM_FOM_SC_SAMDIS.l(ey,l,t)); \
                                         init_oem_fom_equipments(y,l,t)=sum(ey,OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)); \
                                         thermodynamic_efficiency(y,t,f)=sum(ey,N_SAMDIS.l(ey,t,f)); \
                                         init_own_cons_gen_pctg=sum(ey,OWN_CONS_SAMDIS.l(ey)); \
                                         init_overnight_costs(y,t)=sum(ey,OVERN_COSTS_SAMDIS.l(ey,t)); \
                                         tdeo_losses_pctg(l,p,b)=sum(ey,LOSS_SAMDIS.l(ey,l,p,b)); \
                                         initial_prop_export_energy_only_price=sum(ey,EXP_PRICE_PCTG_SAMDIS.l(ey)); \
                                         initial_prop_import_energy_only_price=sum(ey,IMP_PRICE_PCTG_SAMDIS.l(ey)); \
                                         initial_pf_pct_adj(pf)=sum(ey,PF_TDeO_PCTG_SAMDIS.l(ey,pf)); \
                                         co2e_content(f,t)=sum(ey,CO2e_CONTENT_SAMDIS.l(ey,t,f));


$macro   Deviations_by_iteration         oem_vom_dev(iter)=0; oem_fom_labor_dev(iter)=0; oem_fom_social_contribution_dev(iter)=0; oem_fom_equipments_dev(iter)=0; thermodynamic_efficiency_dev(iter)=0; own_cons_gen_pctg_dev(iter)=0; overnight_costs_dev(iter)=0; tdeo_losses_pctg_dev(iter)=0;exp_price_pctg_dev(iter)=0;imp_price_pctg_dev(iter)=0;tdeo_pf_pct_adj_dev(iter)=0;co2e_content_dev(iter)=0; \
                                         if ((exec_MinMax=1 or exec_MinMax_plus_lineal_term=1), max_deviation(iter)=sum((ey,Calibrated_Variables), MAX_PCTG_DEV_SAMDIS.l(ey,Calibrated_Variables)); ); \
                                         loop((ey,t)$first_init_oem_vom(ey,t), oem_vom_dev(iter)$ ( OEM_VOM_SAMDIS.l(ey,t) > oem_vom_dev(iter) ) = ((N_OEM_VOM_SAMDIS.l(ey,t) + P_OEM_VOM_SAMDIS.l(ey,t))/init_oem_vom(ey,t)); ); \
                                         loop((ey,l,t)$first_init_oem_fom_labor(ey,l,t), oem_fom_labor_dev(iter)$ ( OEM_FOM_LABOR_SAMDIS.l(ey,l,t) > oem_fom_labor_dev(iter) ) = OEM_FOM_LABOR_SAMDIS.l(ey,l,t); ); \
                                         loop((ey,l,t)$first_init_oem_fom_social_contribution(ey,l,t), oem_fom_social_contribution_dev(iter)$ ( OEM_FOM_SC_SAMDIS.l(ey,l,t) > oem_fom_social_contribution_dev(iter) ) = OEM_FOM_SC_SAMDIS.l(ey,l,t); ); \
                                         loop((ey,l,t)$first_init_oem_fom_equipments(ey,l,t), oem_fom_equipments_dev(iter)$ ( OEM_FOM_EQUIP_SAMDIS.l(ey,l,t) > oem_fom_equipments_dev(iter) ) = OEM_FOM_EQUIP_SAMDIS.l(ey,l,t); ); \
                                         loop((ey,t,f)$first_thermodynamic_efficiency(ey,t,f), thermodynamic_efficiency_dev(iter)$ ( N_SAMDIS.l(ey,t,f) > thermodynamic_efficiency_dev(iter) ) = N_SAMDIS.l(ey,t,f); ); \
                                         loop((ey), own_cons_gen_pctg_dev(iter)$ ( OWN_CONS_SAMDIS.l(ey) > own_cons_gen_pctg_dev(iter) ) = OWN_CONS_SAMDIS.l(ey); ); \
                                         loop((ey,t)$first_init_overnight_costs(ey,t), overnight_costs_dev(iter)$ ( OVERN_COSTS_SAMDIS.l(ey,t) > overnight_costs_dev(iter) ) = OVERN_COSTS_SAMDIS.l(ey,t); ); \
                                         loop((ey,l,p,b)$first_tdeo_losses_pctg(l,p,b), tdeo_losses_pctg_dev(iter)$ ( LOSS_SAMDIS.l(ey,l,p,b) > tdeo_losses_pctg_dev(iter) ) = LOSS_SAMDIS.l(ey,l,p,b); ); \
                                         loop((ey), exp_price_pctg_dev(iter)$( EXP_PRICE_PCTG_SAMDIS.l(ey) > exp_price_pctg_dev(iter) ) = EXP_PRICE_PCTG_SAMDIS.l(ey); ); \
                                         loop((ey), imp_price_pctg_dev(iter)$( IMP_PRICE_PCTG_SAMDIS.l(ey) > imp_price_pctg_dev(iter) ) = IMP_PRICE_PCTG_SAMDIS.l(ey); ); \
                                         loop((ey,pf), tdeo_pf_pct_adj_dev(iter)$( PF_TDeO_PCTG_SAMDIS.l(ey,pf) > tdeo_pf_pct_adj_dev(iter) ) = PF_TDeO_PCTG_SAMDIS.l(ey,pf); ); \
                                         loop((ey,t,f)$first_co2e_content(f,t), co2e_content_dev(iter)$( CO2e_CONTENT_SAMDIS.l(ey,t,f) > co2e_content_dev(iter) ) = CO2e_CONTENT_SAMDIS.l(ey,t,f); );

$macro   Iteration_results               total_oem_vom_dev(iter)=0; total_oem_fom_labor_dev(iter)=0; total_oem_fom_social_contribution_dev(iter)=0; total_oem_fom_equipments_dev(iter)=0; total_thermodynamic_efficiency_dev(iter)=0; total_own_cons_gen_pctg_dev(iter)=0; total_overnight_costs_dev(iter)=0; total_tdeo_losses_pctg_dev(iter)=0;total_exp_price_pctg_dev(iter)=0;total_imp_price_pctg_dev(iter)=0;total_tdeo_pf_pct_adj_dev(iter)=0;total_co2e_content_dev(iter)=0; \
                                         loop((ey,t)$first_init_oem_vom(ey,t), total_oem_vom_dev(iter)$ ( max(total_oem_vom_dev(iter),abs((OEM_VOM_SAMDIS.l(ey,t)-first_init_oem_vom(ey,t))/first_init_oem_vom(ey,t))) > abs(total_oem_vom_dev(iter)) ) = (OEM_VOM_SAMDIS.l(ey,t)-first_init_oem_vom(ey,t))/first_init_oem_vom(ey,t);); loop((ey,l,t)$first_init_oem_fom_labor(ey,l,t), total_oem_fom_labor_dev(iter)$ ( max(total_oem_fom_labor_dev(iter),abs((OEM_FOM_LABOR_SAMDIS.l(ey,l,t)-first_init_oem_fom_labor(ey,l,t))/first_init_oem_fom_labor(ey,l,t))) > abs(total_oem_fom_labor_dev(iter)) ) = (OEM_FOM_LABOR_SAMDIS.l(ey,l,t)-first_init_oem_fom_labor(ey,l,t))/first_init_oem_fom_labor(ey,l,t););loop((ey,l,t)$first_init_oem_fom_social_contribution(ey,l,t), total_oem_fom_social_contribution_dev(iter)$ ( max(total_oem_fom_social_contribution_dev(iter),abs((OEM_FOM_SC_SAMDIS.l(ey,l,t)-first_init_oem_fom_social_contribution(ey,l,t))/first_init_oem_fom_social_contribution(ey,l,t))) > abs(total_oem_fom_social_contribution_dev(iter)) ) = (OEM_FOM_SC_SAMDIS.l(ey,l,t)-first_init_oem_fom_social_contribution(ey,l,t))/first_init_oem_fom_social_contribution(ey,l,t);); loop((ey,l,t)$first_init_oem_fom_equipments(ey,l,t), total_oem_fom_equipments_dev(iter)$ ( max(total_oem_fom_equipments_dev(iter),abs((OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)-first_init_oem_fom_equipments(ey,l,t))/first_init_oem_fom_equipments(ey,l,t))) > abs(total_oem_fom_equipments_dev(iter)) ) = (OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)-first_init_oem_fom_equipments(ey,l,t))/first_init_oem_fom_equipments(ey,l,t);); loop((ey,t,f)$first_thermodynamic_efficiency(ey,t,f), total_thermodynamic_efficiency_dev(iter)$ ( max(total_thermodynamic_efficiency_dev(iter),abs((N_SAMDIS.l(ey,t,f)-first_thermodynamic_efficiency(ey,t,f))/first_thermodynamic_efficiency(ey,t,f))) > abs(total_thermodynamic_efficiency_dev(iter)) ) = (N_SAMDIS.l(ey,t,f)-first_thermodynamic_efficiency(ey,t,f))/first_thermodynamic_efficiency(ey,t,f);); loop((ey), total_own_cons_gen_pctg_dev(iter)$ ( max(total_own_cons_gen_pctg_dev(iter),abs((OWN_CONS_SAMDIS.l(ey)-first_init_own_cons_gen_pctg)/first_init_own_cons_gen_pctg)) > abs(total_own_cons_gen_pctg_dev(iter)) ) = (OWN_CONS_SAMDIS.l(ey)-first_init_own_cons_gen_pctg)/first_init_own_cons_gen_pctg;); loop((ey,t)$first_init_overnight_costs(ey,t), total_overnight_costs_dev(iter)$ ( max(total_overnight_costs_dev(iter),abs((OVERN_COSTS_SAMDIS.l(ey,t)-first_init_overnight_costs(ey,t))/first_init_overnight_costs(ey,t))) > abs(total_overnight_costs_dev(iter)) ) = (OVERN_COSTS_SAMDIS.l(ey,t)-first_init_overnight_costs(ey,t))/first_init_overnight_costs(ey,t);); loop((ey,l,p,b)$first_tdeo_losses_pctg(l,p,b), total_tdeo_losses_pctg_dev(iter)$ ( max(total_tdeo_losses_pctg_dev(iter),abs((LOSS_SAMDIS.l(ey,l,p,b)-first_tdeo_losses_pctg(l,p,b))/first_tdeo_losses_pctg(l,p,b))) > abs(total_tdeo_losses_pctg_dev(iter)) ) = (LOSS_SAMDIS.l(ey,l,p,b)-first_tdeo_losses_pctg(l,p,b))/first_tdeo_losses_pctg(l,p,b);); loop((ey), total_exp_price_pctg_dev(iter)$ ( max(total_exp_price_pctg_dev(iter),abs((EXP_PRICE_PCTG_SAMDIS.l(ey)-first_exp_price_pctg)/first_exp_price_pctg)) > abs(total_exp_price_pctg_dev(iter)) ) = (EXP_PRICE_PCTG_SAMDIS.l(ey)-first_exp_price_pctg)/first_exp_price_pctg;); loop((ey), total_imp_price_pctg_dev(iter)$ ( max(total_imp_price_pctg_dev(iter),abs((IMP_PRICE_PCTG_SAMDIS.l(ey)-first_imp_price_pctg)/first_imp_price_pctg)) > abs(total_imp_price_pctg_dev(iter)) ) = (IMP_PRICE_PCTG_SAMDIS.l(ey)-first_imp_price_pctg)/first_imp_price_pctg;); loop((ey,pf)$first_tdeo_pf_pct_adj(pf), total_tdeo_pf_pct_adj_dev(iter)$ ( max(total_tdeo_pf_pct_adj_dev(iter),abs((PF_TDeO_PCTG_SAMDIS.l(ey,pf)-first_tdeo_pf_pct_adj(pf))/first_tdeo_pf_pct_adj(pf))) > abs(total_tdeo_pf_pct_adj_dev(iter)) ) = (PF_TDeO_PCTG_SAMDIS.l(ey,pf)-first_tdeo_pf_pct_adj(pf))/first_tdeo_pf_pct_adj(pf);); loop((ey,t,f)$first_co2e_content(f,t), total_co2e_content_dev(iter)$ ( max(total_co2e_content_dev(iter),abs((CO2e_CONTENT_SAMDIS.l(ey,t,f)-first_co2e_content(f,t))/first_co2e_content(f,t))) > abs(total_co2e_content_dev(iter)) ) = (CO2e_CONTENT_SAMDIS.l(ey,t,f)-first_co2e_content(f,t))/first_co2e_content(f,t);); \
                                         average_oem_vom_dev(iter)=sum((ey,t)$first_init_oem_vom(ey,t),abs(OEM_VOM_SAMDIS.l(ey,t)-first_init_oem_vom(ey,t))/first_init_oem_vom(ey,t))/sum((ey,t)$first_init_oem_vom(ey,t),1); average_oem_fom_labor_dev(iter)=sum((ey,l,t)$first_init_oem_fom_labor(ey,l,t), abs(OEM_FOM_LABOR_SAMDIS.l(ey,l,t)-first_init_oem_fom_labor(ey,l,t))/first_init_oem_fom_labor(ey,l,t))/sum((ey,l,t)$first_init_oem_fom_labor(ey,l,t),1);average_oem_fom_social_contribution_dev(iter)=sum((ey,l,t)$first_init_oem_fom_social_contribution(ey,l,t), abs(OEM_FOM_SC_SAMDIS.l(ey,l,t)-first_init_oem_fom_social_contribution(ey,l,t))/first_init_oem_fom_social_contribution(ey,l,t))/sum((ey,l,t)$first_init_oem_fom_social_contribution(ey,l,t),1); average_oem_fom_equipments_dev(iter)= sum((ey,l,t)$first_init_oem_fom_equipments(ey,l,t), abs(OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)-first_init_oem_fom_equipments(ey,l,t))/first_init_oem_fom_equipments(ey,l,t))/sum((ey,l,t)$first_init_oem_fom_equipments(ey,l,t),1); average_thermodynamic_efficiency_dev(iter) = sum((ey,t,f)$first_thermodynamic_efficiency(ey,t,f), abs(N_SAMDIS.l(ey,t,f)-first_thermodynamic_efficiency(ey,t,f))/first_thermodynamic_efficiency(ey,t,f))/sum((ey,t,f)$first_thermodynamic_efficiency(ey,t,f),1); average_own_cons_gen_pctg_dev(iter) =  sum((ey), abs(OWN_CONS_SAMDIS.l(ey)-first_init_own_cons_gen_pctg)/first_init_own_cons_gen_pctg)/sum((ey),1); average_overnight_costs_dev(iter) = sum((ey,t)$first_init_overnight_costs(ey,t), abs(OVERN_COSTS_SAMDIS.l(ey,t)-first_init_overnight_costs(ey,t))/first_init_overnight_costs(ey,t))/sum((ey,t)$first_init_overnight_costs(ey,t),1); average_tdeo_losses_pctg_dev(iter) = sum((ey,l,p,b)$first_tdeo_losses_pctg(l,p,b), abs(LOSS_SAMDIS.l(ey,l,p,b)-first_tdeo_losses_pctg(l,p,b))/first_tdeo_losses_pctg(l,p,b))/sum((ey,l,p,b)$first_tdeo_losses_pctg(l,p,b),1);average_exp_price_pctg_dev(iter)=sum((ey),abs(EXP_PRICE_PCTG_SAMDIS.l(ey)-first_exp_price_pctg)/first_exp_price_pctg)/sum(ey,1); average_imp_price_pctg_dev(iter)=sum((ey),abs(IMP_PRICE_PCTG_SAMDIS.l(ey)-first_imp_price_pctg)/first_imp_price_pctg)/sum(ey,1); average_tdeo_pf_pct_adj_dev(iter)=sum((ey,pf),abs(PF_TDeO_PCTG_SAMDIS.l(ey,pf)-first_tdeo_pf_pct_adj(pf))/first_tdeo_pf_pct_adj(pf))/sum((ey,pf),1); average_co2e_content_dev(iter)=sum((ey,t,f)$first_co2e_content(f,t),abs(CO2e_CONTENT_SAMDIS.l(ey,t,f)-first_co2e_content(f,t))/first_co2e_content(f,t))/sum((ey,t,f)$first_co2e_content(f,t),1); \
                                         concentration_oem_vom_dev(iter)=1-(sum((ey,t)$((first_init_oem_vom(ey,t)) and ((OEM_VOM_SAMDIS.l(ey,t)-first_init_oem_vom(ey,t))/first_init_oem_vom(ey,t)=0)),1))/sum((ey,t)$first_init_oem_vom(ey,t),1); concentration_oem_fom_labor_dev(iter)=1-sum((ey,l,t)$((first_init_oem_fom_labor(ey,l,t)) and ((OEM_FOM_LABOR_SAMDIS.l(ey,l,t)-first_init_oem_fom_labor(ey,l,t))/first_init_oem_fom_labor(ey,l,t)=0)),1)/sum((ey,l,t)$first_init_oem_fom_labor(ey,l,t),1);concentration_oem_fom_social_contribution_dev(iter)=1-sum((ey,l,t)$((first_init_oem_fom_social_contribution(ey,l,t)) and ((OEM_FOM_SC_SAMDIS.l(ey,l,t)-first_init_oem_fom_social_contribution(ey,l,t))/first_init_oem_fom_social_contribution(ey,l,t)=0)),1)/sum((ey,l,t)$first_init_oem_fom_social_contribution(ey,l,t),1); concentration_oem_fom_equipments_dev(iter)= 1-sum((ey,l,t)$((first_init_oem_fom_equipments(ey,l,t)) and ((OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)-first_init_oem_fom_equipments(ey,l,t))/first_init_oem_fom_equipments(ey,l,t)=0)),1)/sum((ey,l,t)$first_init_oem_fom_equipments(ey,l,t),1); concentration_thermodynamic_efficiency_dev(iter) = 1-sum((ey,t,f)$((first_thermodynamic_efficiency(ey,t,f))and((N_SAMDIS.l(ey,t,f)-first_thermodynamic_efficiency(ey,t,f))/first_thermodynamic_efficiency(ey,t,f)=0)),1)/sum((ey,t,f)$first_thermodynamic_efficiency(ey,t,f),1); concentration_own_cons_gen_pctg_dev(iter) =  1-sum((ey)$(((OWN_CONS_SAMDIS.l(ey)-first_init_own_cons_gen_pctg)/first_init_own_cons_gen_pctg=0)),1)/sum((ey),1); concentration_overnight_costs_dev(iter) = 1-sum((ey,t)$((first_init_overnight_costs(ey,t))and((OVERN_COSTS_SAMDIS.l(ey,t)-first_init_overnight_costs(ey,t))/first_init_overnight_costs(ey,t)=0)),1)/sum((ey,t)$first_init_overnight_costs(ey,t),1); concentration_tdeo_losses_pctg_dev(iter) = 1-sum((ey,l,p,b)$((first_tdeo_losses_pctg(l,p,b))and((LOSS_SAMDIS.l(ey,l,p,b)-first_tdeo_losses_pctg(l,p,b))/first_tdeo_losses_pctg(l,p,b)=0)),1)/sum((ey,l,p,b)$first_tdeo_losses_pctg(l,p,b),1); concentration_exp_price_pctg_dev(iter)=1-(sum((ey)$((EXP_PRICE_PCTG_SAMDIS.l(ey)-first_exp_price_pctg)/first_exp_price_pctg=0),1))/sum(ey,1); concentration_imp_price_pctg_dev(iter)=1-(sum((ey)$((IMP_PRICE_PCTG_SAMDIS.l(ey)-first_imp_price_pctg)/first_imp_price_pctg=0),1))/sum(ey,1); concentration_tdeo_pf_pct_adj_dev(iter)=1-(sum((ey,pf)$((PF_TDeO_PCTG_SAMDIS.l(ey,pf)-first_tdeo_pf_pct_adj(pf))/first_tdeo_pf_pct_adj(pf)=0),1))/sum((ey,pf),1); concentration_co2e_content_dev(iter)=1-(sum((ey,t,f)$((co2e_content(f,t)) and ((CO2e_CONTENT_SAMDIS.l(ey,t,f)-first_co2e_content(f,t))/first_co2e_content(f,t)=0)),1))/sum((ey,t,f)$co2e_content(f,t),1);



$macro   LEGEN_results(execution)        parameters PGEN_LEGEN_&execution(eys,t,f,l,p,b),PPUMPED_LEGEN_&execution(eys,l,p,b),RES_LEGEN_&execution(eys,l,p),PINS_LEGEN_&execution(eys,l,t),TOTAL_GENERATION_COST_LEGEN_&execution(eys,l),OBJECTIVE_LEGEN_&execution,INCREASED_DR_LOAD_&execution(eys,l,p,b),DECREASED_DR_LOAD_&execution(eys,l,p,b),CONSERVED_DR_LOAD_&execution(eys,l,p,b),VOM_LEGEN_&execution(eys,t,f,l,p,b),FUEL_COST_LEGEN_&execution(eys,t,f,l,p,b),CO2_PAYMENTS_LEGEN_&execution(eys,t,F,l,p,b),INSTALLED_CAPACITY_LEGEN_&execution(eys,l,t),AMORTIZATION_LEGEN_&execution(eys,l,t),pgen_by_tech_&execution(eys,t,f), energy_only_price_&execution(eys,l,p,b),max_energy_only_price_&execution(eys,l), min_energy_only_price_&execution(eys,l), pondered__energy_only_price_&execution(eys,l),pollutant_by_tech_LEGEN_&execution(eys,t,f,pollut), co2e_by_tech_LEGEN_&execution(eys,t,f), acid_equivalent_by_tech_LEGEN_&execution(eys,t,f), total_pollutant_LEGEN_&execution(eys,pollut), total_co2e_LEGEN_&execution(eys), total_acid_equivalent_LEGEN_&execution(eys),total_conserved_DR_by_year_&execution(eys), total_displaced_DR_by_year_&execution(eys), total_conserved_DR_savings_by_year_&execution(eys),total_displaced_DR_savings_by_year_&execution(eys),total_conserved_DR_savings_&execution,total_displaced_DR_savings_&execution, fuel_cost_DR_&execution(eys,t,f), co2_cost_DR_&execution(eys,t,f), vom_cost_DR_&execution(eys,t,f), renew_premiun_DR_&execution(eys,t,f); \
                                         PGEN_LEGEN_&execution(eys,t,f,l,p,b)=PGEN_LEGEN.l(eys,t,f,l,p,b); \
                                         PPUMPED_LEGEN_&execution(eys,l,p,b)=PPUMPED_LEGEN.l(eys,l,p,b); \
                                         RES_LEGEN_&execution(eys,l,p)=RES_LEGEN.l(eys,l,p); \
                                         PINS_LEGEN_&execution(eys,l,t)=PINS_LEGEN.l(eys,l,t); \
                                         TOTAL_GENERATION_COST_LEGEN_&execution(eys,l)=TOTAL_GENERATION_COST_LEGEN.l(eys,l); \
                                         OBJECTIVE_LEGEN_&execution=OBJECTIVE_LEGEN.l; \
                                         INCREASED_DR_LOAD_&execution(eys,l,p,b)=INCREASED_DR_LOAD.l(eys,l,p,b); \
                                         DECREASED_DR_LOAD_&execution(eys,l,p,b)=DECREASED_DR_LOAD.l(eys,l,p,b); \
                                         CONSERVED_DR_LOAD_&execution(eys,l,p,b)=CONSERVED_DR_LOAD.l(eys,l,p,b); \
                                         VOM_LEGEN_&execution(eys,t,f,l,p,b)=VOM_LEGEN.l(eys,t,f,l,p,b); \
                                         FUEL_COST_LEGEN_&execution(eys,t,f,l,p,b)=FUEL_COST_LEGEN.l(eys,t,f,l,p,b); \
                                         CO2_PAYMENTS_LEGEN_&execution(eys,t,F,l,p,b)=CO2_PAYMENTS_LEGEN.l(eys,t,F,l,p,b); \
                                         INSTALLED_CAPACITY_LEGEN_&execution(eys,l,t)=INSTALLED_CAPACITY_LEGEN.l(eys,l,t); \
                                         AMORTIZATION_LEGEN_&execution(eys,l,t)=AMORTIZATION_LEGEN.l(eys,l,t); \
                                         pgen_by_tech_&execution(eys,t,f)=sum((l,p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)); \
                                         energy_only_price_&execution(eys,l,p,b)=(eq_demand_balance_&execution.m(eys,l,p,b)/duration(l,p,b)*1e6); \
                                         max_energy_only_price_&execution(eys,l)=smax((p,b), energy_only_price_&execution(eys,l,p,b)); \
                                         min_energy_only_price_&execution(eys,l)=smin((p,b), energy_only_price_&execution(eys,l,p,b)); \
                                         pondered__energy_only_price_&execution(eys,l)= sum((p,b),energy_only_price_&execution(eys,l,p,b)*sum((t,f),PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b))) / sum((t,f,p,b),PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)) ; \
                                         pollutant_by_tech_LEGEN_&execution(eys,t,f,pollut)= sum((l,p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)*pollutant_content(t,f,pollut)); \
                                         co2e_by_tech_LEGEN_&execution(eys,t,f) = sum((l,p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)*co2e_content(f,t)/1e6); \
                                         acid_equivalent_by_tech_LEGEN_&execution(eys,t,f) = sum((l,p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)*acid_equivalent_content(f,t)); \
                                         total_pollutant_LEGEN_&execution(eys,pollut) = sum((t,f),pollutant_by_tech_LEGEN_&execution(eys,t,f,pollut)); \
                                         total_co2e_LEGEN_&execution(eys)= sum((t,f), co2e_by_tech_LEGEN_&execution(eys,t,f)); \
                                         total_acid_equivalent_LEGEN_&execution(eys) = sum((t,f), acid_equivalent_by_tech_LEGEN_&execution(eys,t,f)); \
                                         total_conserved_DR_by_year_&execution(eys) = sum((l,p,b),CONSERVED_DR_LOAD.l(eys,l,p,b)*duration(l,p,b)); \
                                         total_displaced_DR_by_year_&execution(eys) = sum((l,p,b),INCREASED_DR_LOAD.l(eys,l,p,b)*duration(l,p,b)); \
                                         total_conserved_DR_savings_by_year_&execution(eys)=sum((l,p,b),CONSERVED_DR_LOAD.l(eys,l,p,b)*energy_only_price_&execution(eys,l,p,b)*duration(l,p,b))/1e6; \
                                         total_displaced_DR_savings_by_year_&execution(eys)=sum((l,p,b),INCREASED_DR_LOAD.l(eys,l,p,b)*energy_only_price_&execution(eys,l,p,b)*duration(l,p,b))/1e6; \
                                         total_conserved_DR_savings_&execution=sum(eys,total_conserved_DR_savings_by_year_&execution(eys)); \
                                         total_displaced_DR_savings_&execution=sum(eys,total_displaced_DR_savings_by_year_&execution(eys)); \
                                         fuel_cost_DR_&execution(eys,t,f)=(first_thermodynamic_efficiency(eys,t,f)*fuel_price(eys,t,f))$(thermal_t(t,f)); \
                                         co2_cost_DR_&execution(eys,t,f)= (first_co2e_content(f,t)*co2_price(eys))$(emitting_t(t,f)); \
                                         vom_cost_DR_&execution(eys,t,f)= (first_init_oem_vom(eys,t))$(t_f(t,f)); \
                                         renew_premiun_DR_&execution(eys,t,f)= (renewable_premium(eys,t))$(renewable_premium_t(t,f)); \






$macro  LEGEN_results_comparison         comparison_scalar(OBJECTIVE_LEGEN) \
                                         comparison_two_dimensions(TOTAL_GENERATION_COST_LEGEN,eys,l) \
                                         comparison_three_dimensions(RES_LEGEN,eys,l,p) \
                                         comparison_three_dimensions(PINS_LEGEN,eys,l,t) \
                                         comparison_three_dimensions(INSTALLED_CAPACITY_LEGEN,eys,l,t) \
                                         comparison_three_dimensions(AMORTIZATION_LEGEN,eys,l,t) \
                                         comparison_four_dimensions(PPUMPED_LEGEN,eys,l,p,b) \
                                         comparison_four_dimensions(INCREASED_DR_LOAD,eys,l,p,b) \
                                         comparison_four_dimensions(DECREASED_DR_LOAD,eys,l,p,b) \
                                         comparison_four_dimensions(CONSERVED_DR_LOAD,eys,l,p,b) \
                                         comparison_six_dimensions(PGEN_LEGEN,eys,t,f,l,p,b) \
                                         comparison_six_dimensions(VOM_LEGEN,eys,t,f,l,p,b) \
                                         comparison_six_dimensions(FUEL_COST_LEGEN,eys,t,f,l,p,b) \
                                         comparison_six_dimensions(CO2_PAYMENTS_LEGEN,eys,t,F,l,p,b) \
                                         comparison_four_dimensions(pollutant_by_tech_LEGEN,eys,t,f,pollut) \
                                         comparison_four_dimensions(energy_only_price,eys,l,p,b) \
                                         comparison_two_dimensions(max_energy_only_price,eys,l) \
                                         comparison_two_dimensions(min_energy_only_price,eys,l) \
                                         comparison_two_dimensions(pondered__energy_only_price,eys,l) \
                                         comparison_three_dimensions(co2e_by_tech_LEGEN,eys,t,f) \
                                         comparison_two_dimensions(total_pollutant_LEGEN,eys,pollut) \
                                         comparison_three_dimensions(pgen_by_tech,eys,t,f) \
                                         comparison_vector(total_co2e_LEGEN,eys) \
                                         comparison_vector(total_acid_equivalent_LEGEN,eys) \
                                         comparison_vector(total_conserved_DR_by_year,eys) \
                                         comparison_vector(total_displaced_DR_by_year,eys) \
                                         comparison_vector(total_conserved_DR_savings_by_year,eys) \
                                         comparison_vector(total_displaced_DR_savings_by_year,eys) \
                                         comparison_scalar(total_conserved_DR_savings) \
                                         comparison_scalar(total_displaced_DR_savings) \
                                         comparison_three_dimensions(fuel_cost_DR,eys,t,f) \
                                         comparison_three_dimensions(co2_cost_DR,eys,t,f) \
                                         comparison_three_dimensions(vom_cost_DR,eys,t,f) \
                                         comparison_three_dimensions(renew_premiun_DR,eys,t,f)


$macro   GEMED_scale_parameters(operator) initial_Q_H_D_GEMED(y,gne)=initial_Q_H_D_GEMED(y,gne) &operator scale_factor; \
                                         initial_Q_H_D_GEN_GEMED(y,l,p,b)=initial_Q_H_D_GEN_GEMED(y,l,p,b) &operator scale_factor; \
                                         initial_Q_H_D_TDeO_GEMED(y)=initial_Q_H_D_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Y_H_GEMED(y)=initial_Y_H_GEMED(y) &operator scale_factor; \
                                         initial_Q_PF_SNE_LABOR_GEMED(y,sne)=initial_Q_PF_SNE_LABOR_GEMED(y,sne) &operator scale_factor; \
                                         initial_Q_PF_SNE_CAPITAL_GEMED(y,sne)=initial_Q_PF_SNE_CAPITAL_GEMED(y,sne) &operator scale_factor; \
                                         initial_Q_VA_GEMED(y,sne)=initial_Q_VA_GEMED(y,sne) &operator scale_factor; \
                                         initial_Q_II_GEMED(y,gne,sne)=initial_Q_II_GEMED(y,gne,sne) &operator scale_factor; \
                                         initial_Q_II_GEN_SNE_GEMED(y,l,p,b,sne)=initial_Q_II_GEN_SNE_GEMED(y,l,p,b,sne) &operator scale_factor; \
                                         initial_Q_II_TDeO_SNE_GEMED(y,sne)=initial_Q_II_TDeO_SNE_GEMED(y,sne) &operator scale_factor; \
                                         initial_Q_S_GEMED(y,sne)=initial_Q_S_GEMED(y,sne) &operator scale_factor; \
                                         initial_Q_M_GEMED(y,gne)=initial_Q_M_GEMED(y,gne) &operator scale_factor; \
                                         initial_Q_D_GEMED(y,gne)=initial_Q_D_GEMED(y,gne) &operator scale_factor; \
                                         initial_Q_EX_GEMED(y,gne)=initial_Q_EX_GEMED(y,gne) &operator scale_factor; \
                                         initial_Q_Q_GEMED(y,gne)=initial_Q_Q_GEMED(y,gne) &operator scale_factor; \
                                         initial_Q_PF_LABOR_TDeO_GEMED(y)=initial_Q_PF_LABOR_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_PF_CAPITAL_TDeO_GEMED(y)=initial_Q_PF_CAPITAL_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_VA_TDeO_GEMED(y)=initial_Q_VA_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_II_GNE_TDeO_GEMED(y,gne)=initial_Q_II_GNE_TDeO_GEMED(y,gne) &operator scale_factor; \
                                         initial_Q_II_GEN_TDeO_GEMED(y,l,dp,db)=initial_Q_II_GEN_TDeO_GEMED(y,l,dp,db) &operator scale_factor; \
                                         initial_Q_II_TDeO_TDeO_GEMED(y)=initial_Q_II_TDeO_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_S_TDeO_GEMED(y)=initial_Q_S_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_D_TDeO_GEMED(y)=initial_Q_D_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_Q_TDeO_GEMED(y)=initial_Q_Q_TDeO_GEMED(y) &operator scale_factor; \
                                         initial_Q_PF_LABOR_GEN_tech_GEMED(y,l,p,b,t)=initial_Q_PF_LABOR_GEN_tech_GEMED(y,l,p,b,t) &operator scale_factor; \
                                         initial_Q_PF_CAPITAL_GEN_tech_GEMED(y,l,p,b,t)=initial_Q_PF_CAPITAL_GEN_tech_GEMED(y,l,p,b,t) &operator scale_factor; \
                                         initial_Q_VA_GEN_tech_GEMED(y,l,p,b,t)=initial_Q_VA_GEN_tech_GEMED(y,l,p,b,t) &operator scale_factor; \
                                         initial_Q_II_GNE_GEN_tech_GEMED(y,gne,l,p,b,t)=initial_Q_II_GNE_GEN_tech_GEMED(y,gne,l,p,b,t) &operator scale_factor; \
                                         initial_Q_II_GEN_GEN_tech_GEMED(y,l,dp,db,gp,gb,t)=initial_Q_II_GEN_GEN_tech_GEMED(y,l,dp,db,gp,gb,t) &operator scale_factor; \
                                         initial_Q_II_TDeO_GEN_tech_GEMED(y,l,p,b,t)=initial_Q_II_TDeO_GEN_tech_GEMED(y,l,p,b,t) &operator scale_factor; \
                                         initial_Q_S_GEN_GEMED(y,l,p,b)=initial_Q_S_GEN_GEMED(y,l,p,b) &operator scale_factor; \
                                         initial_Q_S_TECH_GEMED(y,l,p,b,t)=initial_Q_S_TECH_GEMED(y,l,p,b,t) &operator scale_factor; \
                                         initial_Q_D_GEN_GEMED(y,l,p,b)=initial_Q_D_GEN_GEMED(y,l,p,b) &operator scale_factor; \
                                         initial_Q_Q_GEN_GEMED(y,l,p,b)=initial_Q_Q_GEN_GEMED(y,l,p,b) &operator scale_factor; \
                                         initial_Y_G_GEMED(y)=initial_Y_G_GEMED(y) &operator scale_factor; \
                                         initial_E_G_GEMED(y)=initial_E_G_GEMED(y) &operator scale_factor; \
                                         initial_Y_TAX_GEMED(y)=initial_Y_TAX_GEMED(y) &operator scale_factor; \
                                         initial_S_TOTAL_GEMED(y)=initial_S_TOTAL_GEMED(y) &operator scale_factor; \
                                         initial_S_TOTAL_H_GEMED(y)=initial_S_TOTAL_H_GEMED(y) &operator scale_factor; \
                                         initial_S_TOTAL_G_GEMED(y)=initial_S_TOTAL_G_GEMED(y) &operator scale_factor; \
                                         initial_S_TOTAL_EXT_GEMED(y)=initial_S_TOTAL_EXT_GEMED(y) &operator scale_factor; \
                                         initial_I_TOTAL_GEMED(y)=initial_I_TOTAL_GEMED(y) &operator scale_factor; \
                                         initial_Q_I_D_GEMED(y,gne)=initial_Q_I_D_GEMED(y,gne) &operator scale_factor; \
                                         q_m_GEN(ey,l,p,b)=q_m_GEN(ey,l,p,b) &operator scale_factor; \
                                         q_ex_GEN(ey,l,p,b)=q_ex_GEN(ey,l,p,b) &operator scale_factor; \
                                         e_transf_i_s(ey,i,s)=e_transf_i_s(ey,i,s) &operator scale_factor; \
                                         q_i_pf(ey,i,pf)=q_i_pf(ey,i,pf) &operator scale_factor; \
                                         transf_g_h(ey)=transf_g_h(ey) &operator scale_factor; \
                                         transf_ext_g(ey)=transf_ext_g(ey) &operator scale_factor; \
                                         transf_ext_h(ey)=transf_ext_h(ey) &operator scale_factor; \
                                         transf_ext_k(ey)=transf_ext_k(ey) &operator scale_factor; \
                                         q_gov_initial(ey,gne)=q_gov_initial(ey,gne) &operator scale_factor; \
                                         q_gov_GEN_initial(ey,l,p,b)=q_gov_GEN_initial(ey,l,p,b) &operator scale_factor; \
                                         q_gov_TDeO_initial(ey)=q_gov_TDeO_initial(ey) &operator scale_factor; \
                                         emissions_allowance(ey,l,p,b,t)=emissions_allowance(ey,l,p,b,t) &operator scale_factor; \
                                         electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b)=electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b) &operator scale_factor;

$macro   GEMED_scale_results(operator)   Q_H_D_GEMED.l(ey,gne) = Q_H_D_GEMED.l(ey,gne) &operator scale_factor; \
                                         Q_H_D_GEN_GEMED.l(ey,l,p,b) = Q_H_D_GEN_GEMED.l(ey,l,p,b) &operator scale_factor; \
                                         Q_H_D_TDeO_GEMED.l(ey)=Q_H_D_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Y_H_GEMED.l(ey)=Y_H_GEMED.l(ey) &operator scale_factor; \
                                         Q_PF_SNE_LABOR_GEMED.l(ey,sne)=Q_PF_SNE_LABOR_GEMED.l(ey,sne) &operator scale_factor; \
                                         Q_PF_SNE_CAPITAL_GEMED.l(ey,sne)=Q_PF_SNE_CAPITAL_GEMED.l(ey,sne) &operator scale_factor; \
                                         Q_VA_GEMED.l(ey,sne)=Q_VA_GEMED.l(ey,sne) &operator scale_factor; \
                                         Q_II_GEMED.l(ey,gne,sne)=Q_II_GEMED.l(ey,gne,sne) &operator scale_factor; \
                                         Q_II_GEN_SNE_GEMED.l(ey,l,p,b,sne)=Q_II_GEN_SNE_GEMED.l(ey,l,p,b,sne) &operator scale_factor; \
                                         Q_II_TDeO_SNE_GEMED.l(ey,sne)=Q_II_TDeO_SNE_GEMED.l(ey,sne) &operator scale_factor; \
                                         Q_S_GEMED.l(ey,sne)=Q_S_GEMED.l(ey,sne) &operator scale_factor; \
                                         Q_M_GEMED.l(ey,gne)=Q_M_GEMED.l(ey,gne) &operator scale_factor; \
                                         Q_D_GEMED.l(ey,gne)=Q_D_GEMED.l(ey,gne) &operator scale_factor; \
                                         Q_EX_GEMED.l(ey,gne)=Q_EX_GEMED.l(ey,gne) &operator scale_factor; \
                                         Q_Q_GEMED.l(ey,gne)=Q_Q_GEMED.l(ey,gne) &operator scale_factor; \
                                         Q_PF_LABOR_TDeO_GEMED.l(ey)=Q_PF_LABOR_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_PF_CAPITAL_TDeO_GEMED.l(ey)=Q_PF_CAPITAL_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_VA_TDeO_GEMED.l(ey)=Q_VA_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_II_GNE_TDeO_GEMED.l(ey,gne)=Q_II_GNE_TDeO_GEMED.l(ey,gne) &operator scale_factor; \
                                         Q_II_GEN_TDeO_GEMED.l(ey,l,dp,db)=Q_II_GEN_TDeO_GEMED.l(ey,l,dp,db) &operator scale_factor; \
                                         Q_II_TDeO_TDeO_GEMED.l(ey)=Q_II_TDeO_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_S_TDeO_GEMED.l(ey)=Q_S_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_D_TDeO_GEMED.l(ey)=Q_D_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_Q_TDeO_GEMED.l(ey)=Q_Q_TDeO_GEMED.l(ey) &operator scale_factor; \
                                         Q_PF_LABOR_GEN_tech_GEMED.l(ey,l,p,b,t)=Q_PF_LABOR_GEN_tech_GEMED.l(ey,l,p,b,t) &operator scale_factor; \
                                         Q_PF_CAPITAL_GEN_tech_GEMED.l(ey,l,p,b,t)=Q_PF_CAPITAL_GEN_tech_GEMED.l(ey,l,p,b,t) &operator scale_factor; \
                                         Q_VA_GEN_tech_GEMED.l(ey,l,p,b,t)=Q_VA_GEN_tech_GEMED.l(ey,l,p,b,t) &operator scale_factor; \
                                         Q_II_GNE_GEN_tech_GEMED.l(ey,gne,l,p,b,t)=Q_II_GNE_GEN_tech_GEMED.l(ey,gne,l,p,b,t) &operator scale_factor; \
                                         Q_II_GEN_GEN_tech_GEMED.l(ey,l,dp,db,gp,gb,t)=Q_II_GEN_GEN_tech_GEMED.l(ey,l,dp,db,gp,gb,t) &operator scale_factor; \
                                         Q_II_TDeO_GEN_tech_GEMED.l(ey,l,p,b,t)=Q_II_TDeO_GEN_tech_GEMED.l(ey,l,p,b,t) &operator scale_factor; \
                                         Q_S_GEN_GEMED.l(ey,l,p,b)=Q_S_GEN_GEMED.l(ey,l,p,b) &operator scale_factor; \
                                         Q_S_TECH_GEMED.l(ey,l,p,b,t)=Q_S_TECH_GEMED.l(ey,l,p,b,t) &operator scale_factor; \
                                         Q_D_GEN_GEMED.l(ey,l,p,b)=Q_D_GEN_GEMED.l(ey,l,p,b) &operator scale_factor; \
                                         Q_Q_GEN_GEMED.l(ey,l,p,b)=Q_Q_GEN_GEMED.l(ey,l,p,b) &operator scale_factor; \
                                         Y_G_GEMED.l(ey)=Y_G_GEMED.l(ey) &operator scale_factor; \
                                         E_G_GEMED.l(ey)=E_G_GEMED.l(ey) &operator scale_factor; \
                                         Y_TAX_GEMED.l(ey)=Y_TAX_GEMED.l(ey) &operator scale_factor; \
                                         S_TOTAL_GEMED.l(ey)=S_TOTAL_GEMED.l(ey) &operator scale_factor; \
                                         S_TOTAL_H_GEMED.l(ey)=S_TOTAL_H_GEMED.l(ey) &operator scale_factor; \
                                         S_TOTAL_G_GEMED.l(ey)=S_TOTAL_G_GEMED.l(ey) &operator scale_factor; \
                                         S_TOTAL_EXT_GEMED.l(ey)=S_TOTAL_EXT_GEMED.l(ey) &operator scale_factor; \
                                         I_TOTAL_GEMED.l(ey)=I_TOTAL_GEMED.l(ey) &operator scale_factor; \
                                         Q_I_D_GEMED.l(ey,gne)=Q_I_D_GEMED.l(ey,gne) &operator scale_factor;


$macro   GEMED_CGE_results(execution)    parameters Q_H_D_GEMED_&execution(ey,gne),Q_H_D_GEN_GEMED_&execution(ey,l,p,b),Q_H_D_TDeO_GEMED_&execution(ey),P_PF_LABOR_GEMED_&execution(ey),P_PF_CAPITAL_GEMED_&execution(ey),Y_H_GEMED_&execution,Q_PF_SNE_LABOR_GEMED_&execution,Q_PF_SNE_CAPITAL_GEMED_&execution(ey,sne),Q_VA_GEMED_&execution(ey,sne),P_VA_GEMED_&execution(ey,sne),Q_II_GEMED_&execution(ey,gne,sne),Q_II_GEN_SNE_GEMED_&execution(ey,l,p,b,sne),Q_II_TDeO_SNE_GEMED_&execution,Q_S_GEMED_&execution(ey,sne),P_S_GEMED_&execution(ey,gne),Q_M_GEMED_&execution(ey,gne),Q_D_GEMED_&execution(ey,gne),P_D_GEMED_&execution(ey,gne),Q_EX_GEMED_&execution(ey,gne),Q_Q_GEMED_&execution(ey,gne),P_Q_GEMED_&execution(ey,gne),Q_PF_LABOR_TDeO_GEMED_&execution(ey),Q_PF_CAPITAL_TDeO_GEMED_&execution(ey),Q_VA_TDeO_GEMED_&execution(ey),P_VA_TDeO_GEMED_&execution(ey),Q_II_GNE_TDeO_GEMED_&execution(ey,gne),Q_II_GEN_TDeO_GEMED_&execution(ey,l,dp,db),Q_II_TDeO_TDeO_GEMED_&execution(ey),Q_S_TDeO_GEMED_&execution(ey),P_S_TDeO_GEMED_&execution(ey),Q_D_TDeO_GEMED_&execution(ey),P_D_TDeO_GEMED_&execution(ey),Q_Q_TDeO_GEMED_&execution(ey),P_Q_TDeO_GEMED_&execution(ey),Q_PF_LABOR_GEN_tech_GEMED_&execution(ey,l,p,b,t),Q_PF_CAPITAL_GEN_tech_GEMED_&execution(ey,l,p,b,t),Q_VA_GEN_tech_GEMED_&execution(ey,l,p,b,t),P_VA_GEN_tech_GEMED_&execution(ey,l,p,b,t),Q_II_GNE_GEN_tech_GEMED_&execution(ey,gne,l,p,b,t),Q_II_GEN_GEN_tech_GEMED_&execution(ey,l,dp,db,gp,gb,t),Q_II_TDeO_GEN_tech_GEMED_&execution(ey,l,p,b,t),Q_S_GEN_GEMED_&execution(ey,l,p,b),P_S_GEN_GEMED_&execution(ey,l,p,b),Q_D_GEN_GEMED_&execution(ey,l,p,b),P_D_GEN_GEMED_&execution(ey,l,p,b),Q_Q_GEN_GEMED_&execution(ey,l,p,b),P_Q_GEN_GEMED_&execution(ey,l,p,b),Y_G_GEMED_&execution(ey),E_G_GEMED_&execution(ey),Y_TAX_GEMED_&execution(ey),S_TOTAL_GEMED_&execution(ey),S_TOTAL_H_GEMED_&execution(ey),S_TOTAL_G_GEMED_&execution(ey),S_TOTAL_EXT_GEMED_&execution(ey),I_TOTAL_GEMED_&execution(ey),Q_I_D_GEMED_&execution(ey,gne),CPI_GEMED_&execution(ey),pollutants_GEN_GEMED_&execution(ey,l,p,b,t,pollut),pollutants_sne_GEMED_&execution(ey,sne,pollut),pollutants_i_GEMED_&execution(ey,i,pollut),total_pollutants_GEMED_&execution(ey,pollut),total_co2e_GEMED_&execution(ey),total_acid_equivalent_GEMED_&execution(ey),Q_S_TECH_GEMED_&execution(ey,l,p,b,t),P_S_TECH_GEMED_&execution(ey,l,p,b,t); \
                                         Q_H_D_GEMED_&execution(ey,gne) = Q_H_D_GEMED.l(ey,gne); \
                                         Q_H_D_GEN_GEMED_&execution(ey,l,p,b) = Q_H_D_GEN_GEMED.l(ey,l,p,b); \
                                         Q_H_D_TDeO_GEMED_&execution(ey)=Q_H_D_TDeO_GEMED.l(ey); \
                                         P_PF_LABOR_GEMED_&execution(ey)=P_PF_LABOR_GEMED.l(ey); \
                                         P_PF_CAPITAL_GEMED_&execution(ey)=P_PF_CAPITAL_GEMED.l(ey); \
                                         Y_H_GEMED_&execution(ey)=Y_H_GEMED.l(ey); \
                                         Q_PF_SNE_LABOR_GEMED_&execution(ey,sne)=Q_PF_SNE_LABOR_GEMED.l(ey,sne); \
                                         Q_PF_SNE_CAPITAL_GEMED_&execution(ey,sne)=Q_PF_SNE_CAPITAL_GEMED.l(ey,sne); \
                                         Q_VA_GEMED_&execution(ey,sne)=Q_VA_GEMED.l(ey,sne); \
                                         P_VA_GEMED_&execution(ey,sne)=P_VA_GEMED.l(ey,sne); \
                                         Q_II_GEMED_&execution(ey,gne,sne)=Q_II_GEMED.l(ey,gne,sne); \
                                         Q_II_GEN_SNE_GEMED_&execution(ey,l,p,b,sne)=Q_II_GEN_SNE_GEMED.l(ey,l,p,b,sne); \
                                         Q_II_TDeO_SNE_GEMED_&execution(ey,sne)=Q_II_TDeO_SNE_GEMED.l(ey,sne); \
                                         Q_S_GEMED_&execution(ey,sne)=Q_S_GEMED.l(ey,sne); \
                                         P_S_GEMED_&execution(ey,gne)=P_S_GEMED.l(ey,gne); \
                                         Q_M_GEMED_&execution(ey,gne)=Q_M_GEMED.l(ey,gne); \
                                         Q_D_GEMED_&execution(ey,gne)=Q_D_GEMED.l(ey,gne); \
                                         P_D_GEMED_&execution(ey,gne)=P_D_GEMED.l(ey,gne); \
                                         Q_EX_GEMED_&execution(ey,gne)=Q_EX_GEMED.l(ey,gne); \
                                         Q_Q_GEMED_&execution(ey,gne)=Q_Q_GEMED.l(ey,gne); \
                                         P_Q_GEMED_&execution(ey,gne)=P_Q_GEMED.l(ey,gne); \
                                         Q_PF_LABOR_TDeO_GEMED_&execution(ey)=Q_PF_LABOR_TDeO_GEMED.l(ey); \
                                         Q_PF_CAPITAL_TDeO_GEMED_&execution(ey)=Q_PF_CAPITAL_TDeO_GEMED.l(ey); \
                                         Q_VA_TDeO_GEMED_&execution(ey)=Q_VA_TDeO_GEMED.l(ey); \
                                         P_VA_TDeO_GEMED_&execution(ey)=P_VA_TDeO_GEMED.l(ey); \
                                         Q_II_GNE_TDeO_GEMED_&execution(ey,gne)=Q_II_GNE_TDeO_GEMED.l(ey,gne); \
                                         Q_II_GEN_TDeO_GEMED_&execution(ey,l,dp,db)=Q_II_GEN_TDeO_GEMED.l(ey,l,dp,db); \
                                         Q_II_TDeO_TDeO_GEMED_&execution(ey)=Q_II_TDeO_TDeO_GEMED.l(ey); \
                                         Q_S_TDeO_GEMED_&execution(ey)=Q_S_TDeO_GEMED.l(ey); \
                                         P_S_TDeO_GEMED_&execution(ey)=P_S_TDeO_GEMED.l(ey); \
                                         Q_D_TDeO_GEMED_&execution(ey)=Q_D_TDeO_GEMED.l(ey); \
                                         P_D_TDeO_GEMED_&execution(ey)=P_D_TDeO_GEMED.l(ey); \
                                         Q_Q_TDeO_GEMED_&execution(ey)=Q_Q_TDeO_GEMED.l(ey); \
                                         P_Q_TDeO_GEMED_&execution(ey)=P_Q_TDeO_GEMED.l(ey); \
                                         Q_PF_LABOR_GEN_tech_GEMED_&execution(ey,l,p,b,t)=Q_PF_LABOR_GEN_tech_GEMED.l(ey,l,p,b,t); \
                                         Q_PF_CAPITAL_GEN_tech_GEMED_&execution(ey,l,p,b,t)=Q_PF_CAPITAL_GEN_tech_GEMED.l(ey,l,p,b,t); \
                                         Q_VA_GEN_tech_GEMED_&execution(ey,l,p,b,t)=Q_VA_GEN_tech_GEMED.l(ey,l,p,b,t); \
                                         P_VA_GEN_tech_GEMED_&execution(ey,l,p,b,t)=P_VA_GEN_tech_GEMED.l(ey,l,p,b,t); \
                                         Q_II_GNE_GEN_tech_GEMED_&execution(ey,gne,l,p,b,t)=Q_II_GNE_GEN_tech_GEMED.l(ey,gne,l,p,b,t); \
                                         Q_II_GEN_GEN_tech_GEMED_&execution(ey,l,dp,db,gp,gb,t)=Q_II_GEN_GEN_tech_GEMED.l(ey,l,dp,db,gp,gb,t); \
                                         Q_II_TDeO_GEN_tech_GEMED_&execution(ey,l,p,b,t)=Q_II_TDeO_GEN_tech_GEMED.l(ey,l,p,b,t); \
                                         Q_S_GEN_GEMED_&execution(ey,l,p,b)=Q_S_GEN_GEMED.l(ey,l,p,b); \
                                         P_S_GEN_GEMED_&execution(ey,l,p,b)=P_S_GEN_GEMED.l(ey,l,p,b); \
                                         Q_D_GEN_GEMED_&execution(ey,l,p,b)=Q_D_GEN_GEMED.l(ey,l,p,b); \
                                         P_D_GEN_GEMED_&execution(ey,l,p,b)=P_D_GEN_GEMED.l(ey,l,p,b); \
                                         Q_Q_GEN_GEMED_&execution(ey,l,p,b)=Q_Q_GEN_GEMED.l(ey,l,p,b); \
                                         P_Q_GEN_GEMED_&execution(ey,l,p,b)=P_Q_GEN_GEMED.l(ey,l,p,b); \
                                         Y_G_GEMED_&execution(ey)=Y_G_GEMED.l(ey); \
                                         E_G_GEMED_&execution(ey)=E_G_GEMED.l(ey); \
                                         Y_TAX_GEMED_&execution(ey)=Y_TAX_GEMED.l(ey); \
                                         S_TOTAL_GEMED_&execution(ey)=S_TOTAL_GEMED.l(ey); \
                                         S_TOTAL_H_GEMED_&execution(ey)=S_TOTAL_H_GEMED.l(ey); \
                                         S_TOTAL_G_GEMED_&execution(ey)=S_TOTAL_G_GEMED.l(ey); \
                                         S_TOTAL_EXT_GEMED_&execution(ey)=S_TOTAL_EXT_GEMED.l(ey); \
                                         I_TOTAL_GEMED_&execution(ey)=I_TOTAL_GEMED.l(ey); \
                                         Q_I_D_GEMED_&execution(ey,gne)=Q_I_D_GEMED.l(ey,gne); \
                                         CPI_GEMED_&execution(ey)=CPI_GEMED.l(ey); \
                                         Q_S_TECH_GEMED_&execution(ey,l,p,b,t)=Q_S_TECH_GEMED.l(ey,l,p,b,t); \
                                         P_S_TECH_GEMED_&execution(ey,l,p,b,t)=P_S_TECH_GEMED.l(ey,l,p,b,t); \
                                         pollutants_GEN_GEMED_&execution(ey,l,p,b,t,pollut) = sum(f, PGEN_LEGEN.l(ey,t,f,l,p,b)*duration(l,p,b)*pollutant_content(t,f,pollut))*( Q_S_TECH_GEMED.l(ey,l,p,b,t) / initial_Q_S_TECH_GEMED(ey,l,p,b,t) ); \
                                         pollutants_sne_GEMED_&execution(ey,sne,pollut)=top_down_pollutants(sne,pollut)*( Q_S_GEMED.l(ey,sne) / initial_Q_S_GEMED(ey,sne) ); \
                                         pollutants_i_GEMED_&execution(ey,"households",pollut)=top_down_pollutants("households",pollut)*( ( sum(gne, Q_H_D_GEMED.l(ey,gne)*P_Q_GEMED.l(ey,gne)) + sum((l,p,b), Q_H_D_GEN_GEMED.l(ey,l,p,b)*P_Q_GEN_GEMED.l(ey,l,p,b) ) + Q_H_D_TDeO_GEMED.l(ey)*P_Q_TDeO_GEMED.l(ey) ) / ( sum(gne, initial_Q_H_D_GEMED(ey,gne)*initial_P_Q_GEMED(ey,gne)) + sum((l,p,b), initial_Q_H_D_GEN_GEMED(ey,l,p,b)*initial_P_Q_GEN_GEMED(ey,l,p,b) ) + initial_Q_H_D_TDeO_GEMED(ey)*initial_P_Q_TDeO_GEMED(ey) ) ); \
                                         total_pollutants_GEMED_&execution(ey,pollut)=sum((l,p,b,t), pollutants_GEN_GEMED_&execution(ey,l,p,b,t,pollut)) + sum(sne, pollutants_sne_GEMED_&execution(ey,sne,pollut)) + pollutants_i_GEMED_&execution(ey,"households",pollut); \
                                         total_co2e_GEMED_&execution(ey)=sum(co2e_pollut, (total_pollutants_GEMED_&execution(ey,co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CO2")) + (total_pollutants_GEMED_&execution(ey,co2e_pollut)*1e3*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CH4") or sameas(co2e_pollut,"N2O")) +  (total_pollutants_GEMED_&execution(ey,co2e_pollut)*1e6*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"SF6") or sameas(co2e_pollut,"HFC") or sameas(co2e_pollut,"PFC")) ); \
                                         total_acid_equivalent_GEMED_&execution(ey)=sum(acid_pollut, total_pollutants_GEMED_&execution(ey,acid_pollut)*acid_equivalence_by_pollutant(acid_pollut));


$macro  GEMED_CGE_results_comparison     comparison_vector(Q_H_D_TDeO_GEMED,ey) \
                                         comparison_vector(P_PF_LABOR_GEMED,ey) \
                                         comparison_vector(P_PF_CAPITAL_GEMED,ey) \
                                         comparison_vector(Y_H_GEMED,ey) \
                                         comparison_vector(Q_PF_LABOR_TDeO_GEMED,ey) \
                                         comparison_vector(Q_PF_CAPITAL_TDeO_GEMED,ey) \
                                         comparison_vector(Q_VA_TDeO_GEMED,ey) \
                                         comparison_vector(P_VA_TDeO_GEMED,ey) \
                                         comparison_vector(Q_II_TDeO_TDeO_GEMED,ey) \
                                         comparison_vector(Q_S_TDeO_GEMED,ey) \
                                         comparison_vector(P_S_TDeO_GEMED,ey) \
                                         comparison_vector(Q_D_TDeO_GEMED,ey) \
                                         comparison_vector(P_D_TDeO_GEMED,ey) \
                                         comparison_vector(Q_Q_TDeO_GEMED,ey) \
                                         comparison_vector(P_Q_TDeO_GEMED,ey) \
                                         comparison_vector(Y_G_GEMED,ey) \
                                         comparison_vector(E_G_GEMED,ey) \
                                         comparison_vector(Y_TAX_GEMED,ey) \
                                         comparison_vector(S_TOTAL_GEMED,ey) \
                                         comparison_vector(S_TOTAL_H_GEMED,ey) \
                                         comparison_vector(S_TOTAL_G_GEMED,ey) \
                                         comparison_vector(S_TOTAL_EXT_GEMED,ey) \
                                         comparison_vector(I_TOTAL_GEMED,ey) \
                                         comparison_vector(CPI_GEMED,ey) \
                                         comparison_two_dimensions(Q_H_D_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_PF_SNE_LABOR_GEMED,ey,sne) \
                                         comparison_two_dimensions(Q_PF_SNE_CAPITAL_GEMED,ey,sne) \
                                         comparison_two_dimensions(Q_VA_GEMED,ey,sne) \
                                         comparison_two_dimensions(P_VA_GEMED,ey,sne) \
                                         comparison_two_dimensions(Q_II_TDeO_SNE_GEMED,ey,sne) \
                                         comparison_two_dimensions(Q_S_GEMED,ey,sne) \
                                         comparison_two_dimensions(P_S_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_M_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_D_GEMED,ey,gne) \
                                         comparison_two_dimensions(P_D_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_EX_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_Q_GEMED,ey,gne) \
                                         comparison_two_dimensions(P_Q_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_II_GNE_TDeO_GEMED,ey,gne) \
                                         comparison_two_dimensions(Q_I_D_GEMED,ey,gne) \
                                         comparison_three_dimensions(Q_II_GEMED,ey,gne,sne) \
                                         comparison_four_dimensions(Q_H_D_GEN_GEMED,ey,l,p,b) \
                                         comparison_four_dimensions(Q_II_GEN_TDeO_GEMED,ey,l,dp,db) \
                                         comparison_four_dimensions(Q_S_GEN_GEMED,ey,l,p,b) \
                                         comparison_four_dimensions(P_S_GEN_GEMED,ey,l,p,b) \
                                         comparison_four_dimensions(Q_D_GEN_GEMED,ey,l,p,b) \
                                         comparison_four_dimensions(P_D_GEN_GEMED,ey,l,p,b) \
                                         comparison_four_dimensions(Q_Q_GEN_GEMED,ey,l,p,b) \
                                         comparison_four_dimensions(P_Q_GEN_GEMED,ey,l,p,b) \
                                         comparison_five_dimensions(Q_II_GEN_SNE_GEMED,ey,l,p,b,sne) \
                                         comparison_five_dimensions(Q_PF_LABOR_GEN_tech_GEMED,ey,l,p,b,t) \
                                         comparison_five_dimensions(Q_PF_CAPITAL_GEN_tech_GEMED,ey,l,p,b,t) \
                                         comparison_five_dimensions(Q_VA_GEN_tech_GEMED,ey,l,p,b,t) \
                                         comparison_five_dimensions(P_VA_GEN_tech_GEMED,ey,l,p,b,t) \
                                         comparison_five_dimensions(Q_II_TDeO_GEN_tech_GEMED,ey,l,p,b,t) \
                                         comparison_six_dimensions(Q_II_GNE_GEN_tech_GEMED,ey,gne,l,p,b,t) \
                                         comparison_seven_dimensions(Q_II_GEN_GEN_tech_GEMED,ey,l,dp,db,gp,gb,t) \
                                         comparison_five_dimensions(Q_S_TECH_GEMED,ey,l,p,b,t) \
                                         comparison_five_dimensions(P_S_TECH_GEMED,ey,l,p,b,t)


$macro  GEMED_CGE_emissions_results_comparison comparison_six_dimensions(pollutants_GEN_GEMED,ey,l,p,b,t,pollut) \
                                         comparison_two_dimensions(total_pollutants_GEMED,ey,pollut) \
                                         comparison_three_dimensions(pollutants_sne_GEMED,ey,sne,pollut) \
                                         comparison_three_dimensions(pollutants_i_GEMED,ey,i,pollut) \
                                         comparison_vector(total_co2e_GEMED,ey) \
                                         comparison_vector(total_acid_equivalent_GEMED,ey)

$macro   comparison_scalar(variable_name) parameter report_scalar(*,execution); \
                                         report_scalar("variable_name","BAU") = variable_name&_BAU; \
                                         report_scalar("variable_name","CASE_STUDY") = variable_name&_Case_study; \
                                         report_scalar("variable_name","DIFFERENCE") = variable_name&_Case_study - variable_name&_BAU; \
                                         report_scalar("variable_name","PERCENTAGE_CHANGED")$variable_name&_BAU = report_scalar("variable_name","DIFFERENCE")/variable_name&_BAU; \
*avoid line overflow in cge model                                         loop((execution), if(((report_scalar("variable_name",execution)<1e-7)and(report_scalar("variable_name",execution)>-1e-7)), report_scalar("variable_name",execution)=0;););
*                                         if((report_vector("variable_name","DIFFERENCE")>0 and report_vector("variable_name","BAU")=0), report_vector("variable_name","PERCENTAGE_CHANGED")=inf); \
*                                         if((report_vector("variable_name","DIFFERENCE")<0 and report_vector("variable_name","BAU")=0), report_vector("variable_name","PERCENTAGE_CHANGED")=-inf);

$macro   comparison_vector(variable_name,dim1) parameter report_vector(*,*,execution); \
                                         report_vector("variable_name",dim1,"BAU") = variable_name&_BAU(dim1); \
                                         report_vector("variable_name",dim1,"CASE_STUDY") = variable_name&_Case_study(dim1); \
                                         report_vector("variable_name",dim1,"DIFFERENCE") = variable_name&_Case_study(dim1) - variable_name&_BAU(dim1); \
                                         report_vector("variable_name",dim1,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1) = report_vector("variable_name",dim1,"DIFFERENCE")/variable_name&_BAU(dim1); \
*avoid line overflow in cge model                                         loop((execution,dim1), if(((report_vector("variable_name",dim1,execution)<1e-7)and(report_vector("variable_name",dim1,execution)>-1e-7)), report_vector("variable_name",dim1,execution)=0;););
*                                         loop((dim1), if((report_vector("variable_name",dim1,"DIFFERENCE")>0 and report_vector("variable_name",dim1,"BAU")=0), report_vector("variable_name",dim1,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1), if((report_vector("variable_name",dim1,"DIFFERENCE")<0 and report_vector("variable_name",dim1,"BAU")=0), report_vector("variable_name",dim1,"PERCENTAGE_CHANGED")=inf););

$macro   comparison_two_dimensions(variable_name,dim1,dim2) parameter report_two_dimensions(*,*,*,execution); \
                                         report_two_dimensions("variable_name",dim1,dim2,"BAU") = variable_name&_BAU(dim1,dim2); \
                                         report_two_dimensions("variable_name",dim1,dim2,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2); \
                                         report_two_dimensions("variable_name",dim1,dim2,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2) - variable_name&_BAU(dim1,dim2); \
                                         report_two_dimensions("variable_name",dim1,dim2,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2) = report_two_dimensions("variable_name",dim1,dim2,"DIFFERENCE")/variable_name&_BAU(dim1,dim2); \
*avoid line overflow in cge model                                         loop((execution,dim1,dim2), if(((report_two_dimensions("variable_name",dim1,dim2,execution)<1e-7)and(report_two_dimensions("variable_name",dim1,dim2,execution)>-1e-7)) , report_two_dimensions("variable_name",dim1,dim2,execution)=0;););
*                                         loop((dim1,dim2), if((report_two_dimensions("variable_name",dim1,dim2,"DIFFERENCE")>0 and report_two_dimensions("variable_name",dim1,dim2,"BAU")=0), report_two_dimensions("variable_name",dim1,dim2,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1,dim2), if((report_two_dimensions("variable_name",dim1,dim2,"DIFFERENCE")<0 and report_two_dimensions("variable_name",dim1,dim2,"BAU")=0), report_two_dimensions("variable_name",dim1,dim2,"PERCENTAGE_CHANGED")=-inf););

$macro   comparison_three_dimensions(variable_name,dim1,dim2,dim3) parameter report_three_dimensions(*,*,*,*,execution); \
                                         report_three_dimensions("variable_name",dim1,dim2,dim3,"BAU") = variable_name&_BAU(dim1,dim2,dim3); \
                                         report_three_dimensions("variable_name",dim1,dim2,dim3,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3); \
                                         report_three_dimensions("variable_name",dim1,dim2,dim3,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3) - variable_name&_BAU(dim1,dim2,dim3); \
                                         report_three_dimensions("variable_name",dim1,dim2,dim3,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3) = report_three_dimensions("variable_name",dim1,dim2,dim3,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3); \
*avoid line overflow in cge model                                         loop((execution,dim1,dim2,dim3), if(((report_three_dimensions("variable_name",dim1,dim2,dim3,execution)<1e-7)and(report_three_dimensions("variable_name",dim1,dim2,dim3,execution)>-1e-7)), report_three_dimensions("variable_name",dim1,dim2,dim3,execution)=0;););
*                                         loop((dim1,dim2,dim3), if((report_three_dimensions("variable_name",dim1,dim2,dim3,"DIFFERENCE")>0 and report_three_dimensions("variable_name",dim1,dim2,dim3,"BAU")=0), report_three_dimensions("variable_name",dim1,dim2,dim3,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1,dim2,dim3), if((report_three_dimensions("variable_name",dim1,dim2,dim3,"DIFFERENCE")<0 and report_three_dimensions("variable_name",dim1,dim2,dim3,"BAU")=0), report_three_dimensions("variable_name",dim1,dim2,dim3,"PERCENTAGE_CHANGED")=-inf););

$macro   comparison_four_dimensions(variable_name,dim1,dim2,dim3,dim4) parameter report_four_dimensions(*,*,*,*,*,execution); \
                                         report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4); \
                                         report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4); \
                                         report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4) - variable_name&_BAU(dim1,dim2,dim3,dim4); \
                                         report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4) = report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4); \
*avoid line overflow in cge model                                         loop((execution,dim1,dim2,dim3,dim4), if(((report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,execution)<1e-7)and(report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,execution)>-1e-7)), report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,execution)=0;););
*                                         loop((dim1,dim2,dim3,dim4), if((report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"DIFFERENCE")>0 and report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"BAU")=0), report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1,dim2,dim3,dim4), if((report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"DIFFERENCE")<0 and report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"BAU")=0), report_four_dimensions("variable_name",dim1,dim2,dim3,dim4,"PERCENTAGE_CHANGED")=-inf););

$macro   comparison_five_dimensions(variable_name,dim1,dim2,dim3,dim4,dim5) parameter report_five_dimensions(*,*,*,*,*,*,execution); \
                                         report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4,dim5); \
                                         report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5); \
                                         report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5) - variable_name&_BAU(dim1,dim2,dim3,dim4,dim5); \
                                         report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4,dim5) = report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4,dim5); \
*avoid line overflow in cge model                                         loop((execution,dim1,dim2,dim3,dim4,dim5), if(((report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,execution)<1e-7)and(report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,execution)>-1e-7)), report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,execution)=0;););
*                                         loop((dim1,dim2,dim3,dim4,dim5), if((report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"DIFFERENCE")>0 and report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"BAU")=0), report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1,dim2,dim3,dim4,dim5), if((report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"DIFFERENCE")<0 and report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"BAU")=0), report_five_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,"PERCENTAGE_CHANGED")=-inf););

$macro   comparison_six_dimensions(variable_name,dim1,dim2,dim3,dim4,dim5,dim6) parameter report_six_dimensions(*,*,*,*,*,*,*,execution); \
                                         report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6); \
                                         report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6); \
                                         report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6) - variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6); \
                                         report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6) = report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6); \
*avoid line overflow in cge model                                         loop((execution,dim1,dim2,dim3,dim4,dim5,dim6), if(((report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,execution)<1e-7)and(report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,execution)>-1e-7)), report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,execution)=0;););
*                                         loop((dim1,dim2,dim3,dim4,dim5,dim6), if((report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"DIFFERENCE")>0 and report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"BAU")=0), report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1,dim2,dim3,dim4,dim5,dim6), if((report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"DIFFERENCE")<0 and report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"BAU")=0), report_six_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"PERCENTAGE_CHANGED")=-inf););

$macro   comparison_seven_dimensions(variable_name,dim1,dim2,dim3,dim4,dim5,dim6,dim7) parameter report_seven_dimensions(*,*,*,*,*,*,*,*,execution); \
                                         report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
                                         report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
                                         report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6,dim7) - variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
                                         report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7) = report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
*avoid line overflow in cge model                                         loop((execution,dim1,dim2,dim3,dim4,dim5,dim6,dim7), if(((report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,execution)<1e-7)and(report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,execution)>-1e-7)), report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,execution)=0;););
*                                         loop((dim1,dim2,dim3,dim4,dim5,dim6,dim7), if((report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"DIFFERENCE")>0 and report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"BAU")=0), report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"PERCENTAGE_CHANGED")=inf);); \
*                                         loop((dim1,dim2,dim3,dim4,dim5,dim6,dim7), if((report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"DIFFERENCE")<0 and report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"BAU")=0), report_seven_dimensions("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"PERCENTAGE_CHANGED")=-inf););



$macro   execution_log_file(model_executed) put @5 'model_executed (submodel executed)'  /; \
                                         put @10 ' Optimality status...............................      'model_executed.Tmodstat  /; \
                                         put @10 ' Solver..........................................      'System.SSTRING /; \
                                         put @10 ' Solver status...................................      'model_executed.Tsolstat  /; \
                                         put @10 ' Number of infeasibilities in the solution....... ' model_executed.Numinfes:>12:0  /; \
                                         put @10 ' Sum of infeasibilities in the solution.......... ' model_executed.Suminfes:>12:0  /; \
                                         put @10 ' Number of iterations to solve................... ' model_executed.Iterusd:>12:0  /; \
                                         put @10 ' Number of non-zero elements..................... ' model_executed.Numnz:>12:0  /; \
                                         put @10 ' Number of non linear non-zero elements.......... ' model_executed.NumNLnz:>12:0  /; \
                                         put @10 ' Number of equations............................. ' model_executed.Numequ:>12:0  /; \
                                         put @10 ' Number of variables............................. ' model_executed.Numvar:>12:0  /; \
                                         put @10 ' Memory used (Mb)................................ ' System.MEMORY:>12:0   /; \
                                         put @10 ' Solver execution duration (seconds)............. ' model_executed.etSolver:>12:5   /; \
                                         put /;





********************************* Paper for energy economics demand response results




$macro   DR_energy_economics_results(execution) parameters total_generation_cost_DR_&execution(eys,l),energy_only_price_DR_&execution(eys,l,p,b),generated_power_by_block_DR_&execution(eys,l,p,b),total_generated_power_DR_&execution(eys,l),energy_only_pondered_price_DR_&execution(eys,l),pollutant_by_tech_DR_&execution(eys,l,t,f,pollut),co2e_by_tech_DR_&execution(eys,l,t,f),acid_equivalent_by_tech_DR_&execution(eys,l,t,f),total_pollutant_DR_&execution(eys,l,pollut),total_co2e_DR_&execution(eys,l),total_acid_equivalent_DR_&execution(eys,l),total_conserved_DR_savings_by_year_DR_&execution(eys,l),total_displaced_DR_savings_by_year_DR_&execution(eys,l),total_conserved_DR_savings_DR_&execution(eys,l),total_displaced_DR_savings_DR_&execution(eys,l),total_DR_savings_DR_&execution(eys,l),Q_Q_GEN_DR_&execution(ey,l,p,b),P_Q_GEN_DR_&execution(ey,l,p,b),income_Q_Q_GEN_DR_times_P_Q_GEN_DR_&execution(ey,l,p,b),Q_Q_TDeO_DR_&execution(ey),P_Q_TDeO_DR_&execution(ey),income_Q_Q_TDeO_DR_times_P_Q_TDeO_DR_&execution(ey,l,p,b), Q_Q_DR_&execution(ey,gne),P_Q_DR_&execution(ey,gne),income_Q_Q_DR_times_P_Q_DR_&execution(ey,gne), P_PF_LABOR_DR_&execution(ey),P_PF_CAPITAL_DR_&execution(ey), total_Q_PF_labor_DR_&execution(ey),total_Q_PF_capital_DR_&execution(ey),pollutants_GEN_DR_&execution(ey,l,p,b,t,pollut),pollutants_sne_DR_&execution(ey,sne,pollut),pollutants_i_DR_&execution(ey,i,pollut),total_GEN_pollutants_GEMED_DR_&execution(ey,pollut),total_co2e_GEN_GEMED_DR_&execution(ey),total_co2e_sne_GEMED_DR_&execution(ey,sne),total_co2e_i_GEMED_DR_&execution(ey,i),total_acid_equivalent_GEN_GEMED_DR_&execution(ey),total_acid_equivalent_sne_GEMED_DR_&execution(ey,sne),total_acid_equivalent_i_GEMED_DR_&execution(ey,i),total_GEN_pollutants_by_block_GEMED_DR_&execution(ey,l,p,b,pollut),total_co2e_GEN_by_block_GEMED_DR_&execution(ey,l,p,b),total_acid_equivalent_GEN_by_block_GEMED_DR_&execution(ey,l,p,b),total_Q_Q_GEN_DR_&execution(ey,l),total_pondered_P_Q_GEN_DR_&execution(ey,l), variable_costs_&execution(ey,t,f), initial_tech_var_cost_&execution(ey,t,f); \
                                         total_generation_cost_DR_&execution(eys,l)=TOTAL_GENERATION_COST_LEGEN.l(eys,l); \
                                         energy_only_price_DR_&execution(eys,l,p,b)=(eq_demand_balance_&execution.m(eys,l,p,b)/duration(l,p,b)*1e6); \
                                         generated_power_by_block_DR_&execution(eys,l,p,b)=sum((t,f),PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)); \
                                         total_generated_power_DR_&execution(eys,l)=sum((p,b),generated_power_by_block_DR_&execution(eys,l,p,b)); \
                                         energy_only_pondered_price_DR_&execution(eys,l)= sum((p,b),energy_only_price_DR_&execution(eys,l,p,b)*generated_power_by_block_DR_&execution(eys,l,p,b)) / total_generated_power_DR_&execution(eys,l) ; \
                                         pollutant_by_tech_DR_&execution(eys,l,t,f,pollut)= sum((p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)*pollutant_content(t,f,pollut)); \
                                         co2e_by_tech_DR_&execution(eys,l,t,f) = sum((p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)*co2e_content(f,t)/1e6); \
                                         acid_equivalent_by_tech_DR_&execution(eys,l,t,f) = sum((p,b), PGEN_LEGEN.l(eys,t,f,l,p,b)*duration(l,p,b)*acid_equivalent_content(f,t)); \
                                         total_pollutant_DR_&execution(eys,l,pollut) = sum((t,f),pollutant_by_tech_DR_&execution(eys,l,t,f,pollut)); \
                                         total_co2e_DR_&execution(eys,l)= sum((t,f), co2e_by_tech_DR_&execution(eys,l,t,f)); \
                                         total_acid_equivalent_DR_&execution(eys,l) = sum((t,f), acid_equivalent_by_tech_DR_&execution(eys,l,t,f)); \
                                         total_conserved_DR_savings_by_year_DR_&execution(eys,l)=sum((p,b),CONSERVED_DR_LOAD.l(eys,l,p,b)*energy_only_price_DR_BAU(eys,l,p,b)*duration(l,p,b))/1e6; \
                                         total_displaced_DR_savings_by_year_DR_&execution(eys,l)=sum((p,b),INCREASED_DR_LOAD.l(eys,l,p,b)*energy_only_price_DR_BAU(eys,l,p,b)*duration(l,p,b))/1e6; \
                                         total_conserved_DR_savings_DR_&execution(eys,l)=total_conserved_DR_savings_by_year_DR_&execution(eys,l); \
                                         total_displaced_DR_savings_DR_&execution(eys,l)=total_displaced_DR_savings_by_year_DR_&execution(eys,l); \
                                         total_DR_savings_DR_&execution(eys,l)=total_conserved_DR_savings_by_year_DR_&execution(eys,l)+total_displaced_DR_savings_by_year_DR_&execution(eys,l); \
                                         Q_Q_GEN_DR_&execution(ey,l,p,b)=Q_Q_GEN_GEMED.l(ey,l,p,b); \
                                         P_Q_GEN_DR_&execution(ey,l,p,b)=P_Q_GEN_GEMED.l(ey,l,p,b); \
                                         income_Q_Q_GEN_DR_times_P_Q_GEN_DR_&execution(ey,l,p,b)=Q_Q_GEN_GEMED.l(ey,l,p,b)*P_Q_GEN_GEMED.l(ey,l,p,b); \
                                         Q_Q_TDeO_DR_&execution(ey)=Q_Q_TDeO_GEMED.l(ey); \
                                         P_Q_TDeO_DR_&execution(ey)=P_Q_TDeO_GEMED.l(ey); \
                                         income_Q_Q_TDeO_DR_times_P_Q_TDeO_DR_&execution(ey,l,p,b)=Q_Q_TDeO_GEMED.l(ey)*P_Q_TDeO_GEMED.l(ey); \
                                         Q_Q_DR_&execution(ey,gne)=Q_Q_GEMED.l(ey,gne); \
                                         P_Q_DR_&execution(ey,gne)=P_Q_GEMED.l(ey,gne); \
                                         income_Q_Q_DR_times_P_Q_DR_&execution(ey,gne)=Q_Q_GEMED.l(ey,gne)*P_Q_GEMED.l(ey,gne); \
                                         P_PF_LABOR_DR_&execution(ey)=P_PF_LABOR_GEMED.l(ey); \
                                         P_PF_CAPITAL_DR_&execution(ey)=P_PF_CAPITAL_GEMED.l(ey); \
                                         total_Q_PF_labor_DR_&execution(ey)= sum(sne, Q_PF_SNE_LABOR_GEMED.l(ey,sne))+Q_PF_LABOR_TDeO_GEMED.l(ey)+sum((l,p,b,t),Q_PF_LABOR_GEN_tech_GEMED.l(ey,l,p,b,t)); \
                                         total_Q_PF_capital_DR_&execution(ey)= sum(sne, Q_PF_SNE_CAPITAL_GEMED.l(ey,sne))+Q_PF_CAPITAL_TDeO_GEMED.l(ey)+sum((l,p,b,t),Q_PF_CAPITAL_GEN_tech_GEMED.l(ey,l,p,b,t)); \
                                         pollutants_GEN_DR_&execution(ey,l,p,b,t,pollut) = top_down_pollutants("Electricity",pollut)*( Q_S_TECH_GEMED.l(ey,l,p,b,t) / initial_Q_S_TECH_GEMED(ey,l,p,b,t) ); \
                                         pollutants_sne_DR_&execution(ey,sne,pollut)=top_down_pollutants(sne,pollut)*( Q_S_GEMED.l(ey,sne) / initial_Q_S_GEMED(ey,sne) ); \
                                         pollutants_i_DR_&execution(ey,"households",pollut)=top_down_pollutants("households",pollut)*( ( sum(gne, Q_H_D_GEMED.l(ey,gne)*P_Q_GEMED.l(ey,gne)) + sum((l,p,b), Q_H_D_GEN_GEMED.l(ey,l,p,b)*P_Q_GEN_GEMED.l(ey,l,p,b) ) + Q_H_D_TDeO_GEMED.l(ey)*P_Q_TDeO_GEMED.l(ey) ) / ( sum(gne, initial_Q_H_D_GEMED(ey,gne)*initial_P_Q_GEMED(ey,gne)) + sum((l,p,b), initial_Q_H_D_GEN_GEMED(ey,l,p,b)*initial_P_Q_GEN_GEMED(ey,l,p,b) ) + initial_Q_H_D_TDeO_GEMED(ey)*initial_P_Q_TDeO_GEMED(ey) ) ); \
                                         total_GEN_pollutants_GEMED_DR_&execution(ey,pollut)=sum((l,p,b,t), pollutants_GEN_DR_&execution(ey,l,p,b,t,pollut)); \
                                         total_GEN_pollutants_by_block_GEMED_DR_&execution(ey,l,p,b,pollut)=sum((t), pollutants_GEN_DR_&execution(ey,l,p,b,t,pollut)); \
                                         total_co2e_GEN_GEMED_DR_&execution(ey)=sum(co2e_pollut, (total_GEN_pollutants_GEMED_DR_&execution(ey,co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CO2")) + (total_GEN_pollutants_GEMED_DR_&execution(ey,co2e_pollut)*1e3*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CH4") or sameas(co2e_pollut,"N2O")) +  (total_GEN_pollutants_GEMED_DR_&execution(ey,co2e_pollut)*1e6*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"SF6") or sameas(co2e_pollut,"HFC") or sameas(co2e_pollut,"PFC")) ); \
                                         total_co2e_GEN_by_block_GEMED_DR_&execution(ey,l,p,b)=sum(co2e_pollut, (total_GEN_pollutants_by_block_GEMED_DR_&execution(ey,l,p,b,co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CO2")) + (total_GEN_pollutants_by_block_GEMED_DR_&execution(ey,l,p,b,co2e_pollut)*1e3*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CH4") or sameas(co2e_pollut,"N2O")) +  (total_GEN_pollutants_by_block_GEMED_DR_&execution(ey,l,p,b,co2e_pollut)*1e6*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"SF6") or sameas(co2e_pollut,"HFC") or sameas(co2e_pollut,"PFC")) ); \
                                         total_co2e_sne_GEMED_DR_&execution(ey,sne)=sum(co2e_pollut, (pollutants_sne_DR_&execution(ey,sne,co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CO2")) + (pollutants_sne_DR_&execution(ey,sne,co2e_pollut)*1e3*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CH4") or sameas(co2e_pollut,"N2O")) +  (pollutants_sne_DR_&execution(ey,sne,co2e_pollut)*1e6*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"SF6") or sameas(co2e_pollut,"HFC") or sameas(co2e_pollut,"PFC")) ); \
                                         total_co2e_i_GEMED_DR_&execution(ey,"households")=sum(co2e_pollut, (pollutants_i_DR_&execution(ey,"households",co2e_pollut)*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CO2")) + (pollutants_i_DR_&execution(ey,"households",co2e_pollut)*1e3*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"CH4") or sameas(co2e_pollut,"N2O")) +  (pollutants_i_DR_&execution(ey,"households",co2e_pollut)*1e6*co2e_content_by_pollutant(co2e_pollut))$(sameas(co2e_pollut,"SF6") or sameas(co2e_pollut,"HFC") or sameas(co2e_pollut,"PFC")) ); \
                                         total_acid_equivalent_GEN_by_block_GEMED_DR_&execution(ey,l,p,b)=sum(acid_pollut, total_GEN_pollutants_by_block_GEMED_DR_&execution(ey,l,p,b,acid_pollut)*acid_equivalence_by_pollutant(acid_pollut)); \
                                         total_acid_equivalent_GEN_GEMED_DR_&execution(ey)=sum(acid_pollut, total_GEN_pollutants_GEMED_DR_&execution(ey,acid_pollut)*acid_equivalence_by_pollutant(acid_pollut)); \
                                         total_acid_equivalent_sne_GEMED_DR_&execution(ey,sne)=sum(acid_pollut, pollutants_sne_DR_&execution(ey,sne,acid_pollut)*acid_equivalence_by_pollutant(acid_pollut)); \
                                         total_acid_equivalent_i_GEMED_DR_&execution(ey,"households")=sum(acid_pollut, pollutants_i_DR_&execution(ey,"households",acid_pollut)*acid_equivalence_by_pollutant(acid_pollut)); \
                                         total_Q_Q_GEN_DR_&execution(ey,l)=sum((p,b),Q_Q_GEN_DR_&execution(ey,l,p,b)); \
                                         total_pondered_P_Q_GEN_DR_&execution(ey,l)=sum((p,b),P_Q_GEN_DR_&execution(ey,l,p,b)*Q_Q_GEN_DR_&execution(ey,l,p,b)/total_Q_Q_GEN_DR_&execution(ey,l)); \
                                         variable_costs_&execution(ey,t,f)=TECH_VAR_COST.l(ey,t,f); \
                                         initial_tech_var_cost_&execution(ey,t,f)=exec_fc*(thermodynamic_efficiency(ey,t,f)*fuel_price(ey,t,f))$(thermal_t(t,f)) + exec_co2*(co2e_content(f,t)*co2_price(ey))$(emitting_t(t,f)) + exec_vom*(init_oem_vom(ey,t))$(t_f(t,f)) - exec_renew_prem*(renewable_premium(ey,t))$(renewable_premium_t(t,f)); \

*                                         pollutants_GEN_DR_&execution(ey,l,p,b,t,pollut) = sum(f, PGEN_LEGEN.l(ey,t,f,l,p,b)*duration(l,p,b)*pollutant_content(t,f,pollut))*( Q_S_TECH_GEMED.l(ey,l,p,b,t) / initial_Q_S_TECH_GEMED(ey,l,p,b,t) ); \




$macro  DR_energy_economics_results_comparison comparison_two_dimensions_Case_Study(total_generation_cost_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(total_generated_power_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(energy_only_pondered_price_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(total_co2e_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(total_acid_equivalent_DR,"2005",l) \
                                         comparison_three_dimensions_Case_Study(total_pollutant_DR,"2005",l,pollut) \
                                         comparison_two_dimensions_Case_Study(total_DR_savings_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(total_conserved_DR_savings_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(total_displaced_DR_savings_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(income_Q_Q_DR_times_P_Q_DR,"2005",gne) \
                                         comparison_four_dimensions_Case_Study(Q_Q_GEN_DR,"2005",l,p,b) \
                                         comparison_four_dimensions_Case_Study(P_Q_GEN_DR,"2005",l,p,b) \
                                         comparison_four_dimensions_Case_Study(income_Q_Q_GEN_DR_times_P_Q_GEN_DR,"2005",l,p,b) \
                                         comparison_four_dimensions_Case_Study(income_Q_Q_TDeO_DR_times_P_Q_TDeO_DR,"2005",l,p,b) \
                                         comparison_vector_Case_Study(Q_Q_TDeO_DR,"2005") \
                                         comparison_vector_Case_Study(P_Q_TDeO_DR,"2005") \
                                         comparison_two_dimensions_Case_Study(Q_Q_DR,"2005",gne) \
                                         comparison_two_dimensions_Case_Study(P_Q_DR,"2005",gne) \
                                         comparison_vector_Case_Study(P_PF_LABOR_DR,"2005") \
                                         comparison_vector_Case_Study(P_PF_CAPITAL_DR,"2005") \
                                         comparison_vector_Case_Study(total_Q_PF_labor_DR,"2005") \
                                         comparison_vector_Case_Study(total_Q_PF_capital_DR,"2005") \
                                         comparison_three_dimensions_Case_Study(pollutants_sne_DR,"2005",sne,pollut) \
                                         comparison_three_dimensions_Case_Study(pollutants_i_DR,"2005",i,pollut) \
                                         comparison_two_dimensions_Case_Study(total_GEN_pollutants_GEMED_DR,"2005",pollut) \
                                         comparison_vector_Case_Study(total_co2e_GEN_GEMED_DR,"2005") \
                                         comparison_two_dimensions_Case_Study(total_co2e_sne_GEMED_DR,"2005",sne) \
                                         comparison_two_dimensions_Case_Study(total_co2e_i_GEMED_DR,"2005","households") \
                                         comparison_vector_Case_Study(total_acid_equivalent_GEN_GEMED_DR,"2005") \
                                         comparison_two_dimensions_Case_Study(total_acid_equivalent_sne_GEMED_DR,"2005",sne) \
                                         comparison_two_dimensions_Case_Study(total_acid_equivalent_i_GEMED_DR,"2005","households") \
                                         comparison_five_dimensions_Case_Study(total_GEN_pollutants_by_block_GEMED_DR,"2005",l,p,b,pollut) \
                                         comparison_four_dimensions_Case_Study(total_co2e_GEN_by_block_GEMED_DR,"2005",l,p,b) \
                                         comparison_four_dimensions_Case_Study(total_acid_equivalent_GEN_by_block_GEMED_DR,"2005",l,p,b) \
                                         comparison_four_dimensions_Case_Study(energy_only_price_DR,"2005",l,p,b) \
                                         comparison_four_dimensions_Case_Study(generated_power_by_block_DR,"2005",l,p,b) \
                                         comparison_two_dimensions_Case_Study(total_Q_Q_GEN_DR,"2005",l) \
                                         comparison_two_dimensions_Case_Study(total_pondered_P_Q_GEN_DR,"2005",l) \
                                         comparison_three_dimensions_Case_Study(variable_costs,"2005",t,f) \
                                         comparison_three_dimensions_Case_Study(initial_tech_var_cost,"2005",t,f) \
                                         comparison_six_dimensions_Case_Study(pollutants_GEN_DR,"2005",l,p,b,t,pollut)


$macro   comparison_scalar_Case_Study(variable_name) parameter report_scalar_Case_Study(*,execution); \
                                         report_scalar_Case_Study("variable_name","BAU") = variable_name&_BAU; \
                                         report_scalar_Case_Study("variable_name","CASE_STUDY") = variable_name&_Case_study; \
                                         report_scalar_Case_Study("variable_name","DIFFERENCE") = variable_name&_Case_study - variable_name&_BAU; \
                                         report_scalar_Case_Study("variable_name","PERCENTAGE_CHANGED")$variable_name&_BAU = report_scalar_Case_Study("variable_name","DIFFERENCE")/variable_name&_BAU;

$macro   comparison_vector_Case_Study(variable_name,dim1) parameter report_vector_Case_Study(*,*,execution); \
                                         report_vector_Case_Study("variable_name",dim1,"BAU") = variable_name&_BAU(dim1); \
                                         report_vector_Case_Study("variable_name",dim1,"CASE_STUDY") = variable_name&_Case_study(dim1); \
                                         report_vector_Case_Study("variable_name",dim1,"DIFFERENCE") = variable_name&_Case_study(dim1) - variable_name&_BAU(dim1); \
                                         report_vector_Case_Study("variable_name",dim1,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1) = report_vector_Case_Study("variable_name",dim1,"DIFFERENCE")/variable_name&_BAU(dim1);

$macro   comparison_two_dimensions_Case_Study(variable_name,dim1,dim2) parameter report_two_dimensions_Case_Study(*,*,*,execution); \
                                         report_two_dimensions_Case_Study("variable_name",dim1,dim2,"BAU") = variable_name&_BAU(dim1,dim2); \
                                         report_two_dimensions_Case_Study("variable_name",dim1,dim2,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2); \
                                         report_two_dimensions_Case_Study("variable_name",dim1,dim2,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2) - variable_name&_BAU(dim1,dim2); \
                                         report_two_dimensions_Case_Study("variable_name",dim1,dim2,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2) = report_two_dimensions_Case_Study("variable_name",dim1,dim2,"DIFFERENCE")/variable_name&_BAU(dim1,dim2);

$macro   comparison_three_dimensions_Case_Study(variable_name,dim1,dim2,dim3) parameter report_three_dimensions_Case_Study(*,*,*,*,execution); \
                                         report_three_dimensions_Case_Study("variable_name",dim1,dim2,dim3,"BAU") = variable_name&_BAU(dim1,dim2,dim3); \
                                         report_three_dimensions_Case_Study("variable_name",dim1,dim2,dim3,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3); \
                                         report_three_dimensions_Case_Study("variable_name",dim1,dim2,dim3,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3) - variable_name&_BAU(dim1,dim2,dim3); \
                                         report_three_dimensions_Case_Study("variable_name",dim1,dim2,dim3,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3) = report_three_dimensions_Case_Study("variable_name",dim1,dim2,dim3,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3);

$macro   comparison_four_dimensions_Case_Study(variable_name,dim1,dim2,dim3,dim4) parameter report_four_dimensions_Case_Study(*,*,*,*,*,execution); \
                                         report_four_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4); \
                                         report_four_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4); \
                                         report_four_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4) - variable_name&_BAU(dim1,dim2,dim3,dim4); \
                                         report_four_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4) = report_four_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4);

$macro   comparison_five_dimensions_Case_Study(variable_name,dim1,dim2,dim3,dim4,dim5) parameter report_five_dimensions_Case_Study(*,*,*,*,*,*,execution); \
                                         report_five_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4,dim5); \
                                         report_five_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5); \
                                         report_five_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5) - variable_name&_BAU(dim1,dim2,dim3,dim4,dim5); \
                                         report_five_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4,dim5) = report_five_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4,dim5);

$macro   comparison_six_dimensions_Case_Study(variable_name,dim1,dim2,dim3,dim4,dim5,dim6) parameter report_six_dimensions_Case_Study(*,*,*,*,*,*,*,execution); \
                                         report_six_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6); \
                                         report_six_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6); \
                                         report_six_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6) - variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6); \
                                         report_six_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6) = report_six_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6);

$macro   comparison_seven_dimensions_Case_Study(variable_name,dim1,dim2,dim3,dim4,dim5,dim6,dim7) parameter report_seven_dimensions_Case_Study(*,*,*,*,*,*,*,*,execution); \
                                         report_seven_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"BAU") = variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
                                         report_seven_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"CASE_STUDY") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
                                         report_seven_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"DIFFERENCE") = variable_name&_Case_study(dim1,dim2,dim3,dim4,dim5,dim6,dim7) - variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7); \
                                         report_seven_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"PERCENTAGE_CHANGED")$variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7) = report_seven_dimensions_Case_Study("variable_name",dim1,dim2,dim3,dim4,dim5,dim6,dim7,"DIFFERENCE")/variable_name&_BAU(dim1,dim2,dim3,dim4,dim5,dim6,dim7);


********************************* Paper for energy economics demand response results
