$Title Electricity Model
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         SAM disaggregation in load blocks
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 20, jul, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext


set
n_e_SAM_row(sam)
         / Manufactures, Coal, Oil-Nuclear, Gas, Transport, Other_Services, Labor, Capital, Social_Contributions, Production_Taxes, Product_Tax, CO2_Payments, Households, Government, Saves-Investments, Imports /

n_e_SAM_column(sam)
         / Manufactures, Coal, Oil-Nuclear, Gas, Transport, Other_Services, Labor, Capital, Social_Contributions, Production_Taxes, Product_Tax, CO2_Payments, Households, Government, Saves-Investments, Exports /
;

parameter
SAM_output(y,*,*,*,*,*,*,*,*,*,*,*);

********Unchanged SAM values *************
SAM_output(ey,n_e_SAM_row,"","","","",n_e_SAM_column,"","","","","")=SAM_table(n_e_SAM_row,n_e_SAM_column);
********Changed SAM values *************
SAM_output(ey,gne,"","","","","Electricity","TDeO","","","","")=E_II_QE_TDeO_SAMDIS.l(ey,gne);
SAM_output(ey,gne,"","","","","Electricity","GEN",l,gp,gb,t)=E_II_QE_GEN_SAMDIS.l(ey,gne,l,gp,gb,t);
SAM_output(ey,"Electricity","Power","","","",sne,"","","","","")=E_II_EQ_POWER_SAMDIS.l(ey,sne);
SAM_output(ey,"Electricity","Energy",l,dp,db,sne,"","","","","")=E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,dp,db);
SAM_output(ey,"Electricity","Energy",l,dp,db,"Electricity","TDeO","","","","")=E_II_EE_TDeO_SAMDIS.l(ey,l,dp,db);
SAM_output(ey,"Electricity","Energy",l,dp,db,"Electricity","GEN",l,gp,gb,t)=E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t);
SAM_output(ey,"Government","","","","","Electricity","GEN",l,p,b,t)= - ( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum(f, pgen_SAMDIS(ey,t,f,l,p,b)*duration(l,p,b))/sum((f,p_alias,b_alias), pgen_SAMDIS(ey,t,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) )$ ( NOT (sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0) ) - ( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum((t_alias,f), pgen_SAMDIS(ey,t_alias,f,l,p,b)*duration(l,p,b))/sum((t_alias,f,p_alias,b_alias), pgen_SAMDIS(ey,t_alias,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) ) $ ( sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0 );
SAM_output(ey,pf,"","","","","Electricity","GEN",l,gp,gb,t)=E_F_E_GEN_SAMDIS.l(ey,pf,l,gp,gb,t);
SAM_output(ey,pf,"","","","","Electricity","TDeO","","","","")=E_F_E_TDeO_SAMDIS.l(ey,pf);
SAM_output(ey,tx,"","","","","Electricity","GEN",l,gp,gb,t)=E_TAX_E_GEN_SAMDIS.l(ey,tx,l,gp,gb,t);
SAM_output(ey,tx,"","","","","Electricity","TDeO","","","","")=E_TAX_E_TDeO_SAMDIS.l(ey,tx);
SAM_output(ey,"Imports","","","","","Electricity","GEN",l,gp,gb,"Imports")=E_M_E_GEN_SAMDIS.l(ey,l,gp,gb);
SAM_output(ey,"Imports","","","","","Electricity","TDeO","","","","")=E_M_E_TDeO_SAMDIS.l(ey);
SAM_output(ey,"Capital","","","","","Electricity","GEN",l,p,b,"GEN_market_failure_and_non_accounted_costs")= MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b);
SAM_output(ey,"Electricity","Energy",l,dp,db,i,"","","","","")=E_I_ENERGY_SAMDIS.l(ey,i,l,dp,db);
SAM_output(ey,"Electricity","Power","","","",i,"","","","","")=E_I_POWER_SAMDIS.l(ey,i);
SAM_output(ey,"Electricity","Energy",l,dp,db,"Exports","","","","","")=E_EX_ENERGY_SAMDIS.l(ey,l,dp,db);
SAM_output(ey,"Electricity","Power","","","","Exports","","","","","")=E_EX_POWER_SAMDIS.l(ey);

option SAM_output:0:5:7;

parameter
report_deviations(ey,*,*,*,*,*);
report_deviations(ey,"OEM_VOM","",t,"","base")=first_init_oem_vom(ey,t);
report_deviations(ey,"OEM_VOM","",t,"","calibrated")=OEM_VOM_SAMDIS.l(ey,t);
report_deviations(ey,"OEM_VOM","",t,"","percentage")$first_init_oem_vom(ey,t)=(OEM_VOM_SAMDIS.l(ey,t)-first_init_oem_vom(ey,t))/first_init_oem_vom(ey,t);
report_deviations(ey,"OEM_FOM_LABOR",l,t,"","base")=first_init_oem_fom_labor(ey,l,t);
report_deviations(ey,"OEM_FOM_LABOR",l,t,"","calibrated")=OEM_FOM_LABOR_SAMDIS.l(ey,l,t);
report_deviations(ey,"OEM_FOM_LABOR",l,t,"","percentage")$first_init_oem_fom_labor(ey,l,t)=(OEM_FOM_LABOR_SAMDIS.l(ey,l,t)-first_init_oem_fom_labor(ey,l,t))/first_init_oem_fom_labor(ey,l,t);
report_deviations(ey,"OEM_FOM_SC",l,t,"","base")=first_init_oem_fom_social_contribution(ey,l,t);
report_deviations(ey,"OEM_FOM_SC",l,t,"","calibrated")=OEM_FOM_SC_SAMDIS.l(ey,l,t);
report_deviations(ey,"OEM_FOM_SC",l,t,"","percentage")$first_init_oem_fom_social_contribution(ey,l,t)=(OEM_FOM_SC_SAMDIS.l(ey,l,t)-first_init_oem_fom_social_contribution(ey,l,t))/first_init_oem_fom_social_contribution(ey,l,t);
report_deviations(ey,"OEM_FOM_EQUIP",l,t,"","base")=first_init_oem_fom_equipments(ey,l,t);
report_deviations(ey,"OEM_FOM_EQUIP",l,t,"","calibrated")=OEM_FOM_EQUIP_SAMDIS.l(ey,l,t);
report_deviations(ey,"OEM_FOM_EQUIP",l,t,"","percentage")$first_init_oem_fom_equipments(ey,l,t)=(OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)-first_init_oem_fom_equipments(ey,l,t))/first_init_oem_fom_equipments(ey,l,t);
report_deviations(ey,"Therm_eff",t,f,"","base")=first_thermodynamic_efficiency(ey,t,f);
report_deviations(ey,"Therm_eff",t,f,"","calibrated")=N_SAMDIS.l(ey,t,f);
report_deviations(ey,"Therm_eff",t,f,"","percentage")$first_thermodynamic_efficiency(ey,t,f)=(N_SAMDIS.l(ey,t,f)-first_thermodynamic_efficiency(ey,t,f))/first_thermodynamic_efficiency(ey,t,f);
report_deviations(ey,"OWN_CONS","","","","base")=first_init_own_cons_gen_pctg;
report_deviations(ey,"OWN_CONS","","","","calibrated")=OWN_CONS_SAMDIS.l(ey);
report_deviations(ey,"OWN_CONS","","","","percentage")$first_init_own_cons_gen_pctg=(OWN_CONS_SAMDIS.l(ey)-first_init_own_cons_gen_pctg)/first_init_own_cons_gen_pctg;
report_deviations(ey,"OVERN_COSTS","",t,"","base")=first_init_overnight_costs(ey,t);
report_deviations(ey,"OVERN_COSTS","",t,"","calibrated")=OVERN_COSTS_SAMDIS.l(ey,t);
report_deviations(ey,"OVERN_COSTS","",t,"","percentage")$first_init_overnight_costs(ey,t)=(OVERN_COSTS_SAMDIS.l(ey,t)-first_init_overnight_costs(ey,t))/first_init_overnight_costs(ey,t);
report_deviations(ey,"LOSS",l,p,b,"base")=first_tdeo_losses_pctg(l,p,b);
report_deviations(ey,"LOSS",l,p,b,"calibrated")=LOSS_SAMDIS.l(ey,l,p,b);
report_deviations(ey,"LOSS",l,p,b,"percentage")$first_tdeo_losses_pctg(l,p,b)=(LOSS_SAMDIS.l(ey,l,p,b)-first_tdeo_losses_pctg(l,p,b))/first_tdeo_losses_pctg(l,p,b);
report_deviations(ey,"EXP_PRICE","","","","base")=first_exp_price_pctg;
report_deviations(ey,"EXP_PRICE","","","","calibrated")=EXP_PRICE_PCTG_SAMDIS.l(ey);
report_deviations(ey,"EXP_PRICE","","","","percentage")$first_exp_price_pctg=(EXP_PRICE_PCTG_SAMDIS.l(ey)-first_exp_price_pctg)/first_exp_price_pctg;
report_deviations(ey,"IMP_PRICE","","","","base")=first_imp_price_pctg;
report_deviations(ey,"IMP_PRICE","","","","calibrated")=IMP_PRICE_PCTG_SAMDIS.l(ey);
report_deviations(ey,"IMP_PRICE","","","","percentage")$first_imp_price_pctg=(IMP_PRICE_PCTG_SAMDIS.l(ey)-first_imp_price_pctg)/first_imp_price_pctg;
report_deviations(ey,"PF_TDeO",pf,"","","base")=first_tdeo_pf_pct_adj(pf);
report_deviations(ey,"PF_TDeO",pf,"","","calibrated")=PF_TDeO_PCTG_SAMDIS.l(ey,pf);
report_deviations(ey,"PF_TDeO",pf,"","","percentage")$first_tdeo_pf_pct_adj(pf)=(PF_TDeO_PCTG_SAMDIS.l(ey,pf)-first_tdeo_pf_pct_adj(pf))/first_tdeo_pf_pct_adj(pf);
report_deviations(ey,"first_co2e_content","",t,f,"base")=first_co2e_content(f,t);
report_deviations(ey,"first_co2e_content","",t,f,"calibrated")=CO2e_CONTENT_SAMDIS.l(ey,t,f);
report_deviations(ey,"first_co2e_content","",t,f,"percentage")$first_co2e_content(f,t)=(CO2e_CONTENT_SAMDIS.l(ey,t,f)-first_co2e_content(f,t))/first_co2e_content(f,t);
report_deviations(ey,"BU_market_failures_and_non_accounted_costs",l,p,b,"base")=BU_market_failures_and_non_accounted_costs(ey,l,p,b);
report_deviations(ey,"BU_market_failures_and_non_accounted_costs",l,p,b,"calibrated")=MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b);
report_deviations(ey,"BU_market_failures_and_non_accounted_costs",l,p,b,"percentage")$BU_market_failures_and_non_accounted_costs(ey,l,p,b)=(MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b)-BU_market_failures_and_non_accounted_costs(ey,l,p,b))/BU_market_failures_and_non_accounted_costs(ey,l,p,b);

option report_deviations:2:5:1

*---------Declaration of auxiliary file-------
file TMP /tmp.txt/
put TMP  putclose
                         'par=SAM_output rng=Disaggregated_SAM!D6 Rdim=6' /
                         'par=report_deviations rng=Deviations!D6 Rdim=5'

*---------GAMs loading data-------------------
execute_unload "results.gdx"

*---------GAMs loading data-------------------
execute        'gdxxrw.exe results.gdx o="Output_Model_%Model%_%Load_Block_Aggregation%_%Calibration_Problem%_%Years_Simulated%_SAM_Disaggregation.xlsx" SQ=n Squeeze=0 EpsOut=0 @tmp.txt'

*---------Deleting Auxiliary Files--
execute 'del tmp.txt results.gdx';







